﻿local AddonName,ns = ...

local Guide = Guide
local L = Guide.Locale
local GAP = 8
local tekcheck = LibStub("tekKonfig-Checkbox")
local tekbutton = LibStub("tekKonfig-Button")

local frame = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer)
Guide.configpanel = frame
frame.name = "Booster"
frame:Hide()
frame:SetScript("OnShow", function()
  local title, subtitle = LibStub("tekKonfig-Heading").new(frame, "Booster", L["These settings are saved on a per-char basis."])

  local qtrack = tekcheck.new(frame, nil, L["Automatically track quests"], "TOPLEFT", subtitle, "BOTTOMLEFT", -2, -GAP)
  qtrack.tiptext = L["Automatically toggle the default quest tracker for current 'complete quest' objectives."]
  local checksound = qtrack:GetScript("OnClick")
  qtrack:SetScript("OnClick", function(self) checksound(self); Guide.db.char.trackquests = not Guide.db.char.trackquests end)
  qtrack:SetChecked(Guide.db.char.trackquests)


  local showstatusframe = tekcheck.new(frame, nil, L["Show status frame"], "TOPLEFT", qtrack, "BOTTOMLEFT", 0, -GAP)
  showstatusframe.tiptext = L["Display the status frame with current quest objective."]
  showstatusframe:SetScript("OnClick", function(self) checksound(self); Guide.db.char.showstatusframe = not Guide.db.char.showstatusframe; Guide:PositionStatusFrame() end)
  showstatusframe:SetChecked(Guide.db.char.showstatusframe)

  local resetpos = tekbutton.new_small(frame, "TOP", showstatusframe, "CENTER", 0, 11)
  resetpos:SetPoint("RIGHT", -16, 0)
  resetpos:SetText(L["Reset"])
  resetpos.tiptext = L["Reset the status frame to the default position"]
  resetpos:SetScript("OnClick", function(self)
    Guide.db.profile.statusframepoint, Guide.db.profile.statusframex, Guide.db.profile.statusframey = "CENTER", 0, 0;
		ManaCore.dbpc.statusframe_detached = false;
    Guide:PositionStatusFrame()
  end)


  local showuseitem = tekcheck.new(frame, nil, L["Show item button"], "TOPLEFT", showstatusframe, "BOTTOMLEFT", 0, -GAP)
  showuseitem.tiptext = L["Display a button when you must use an item to start or complete a quest."]
  showuseitem:SetChecked(Guide.db.char.showuseitem)

  local resetpos2 = tekbutton.new_small(frame, "TOP", showuseitem, "CENTER", 0, 11)
  resetpos2:SetPoint("RIGHT", -16, 0)
  resetpos2:SetText(L["Reset"])
  resetpos2.tiptext = L["Reset the item button to the default position"]
  resetpos2:SetScript("OnClick", function(self)
    Guide.db.profile.itemframepoint, Guide.db.profile.itemframex, Guide.db.profile.itemframey = nil
    Guide:PositionItemFrame()
  end)

	--[[
  local showuseitemcomplete, showuseitemcompletelabel = tekcheck.new(frame, nil, L["Show buttom for 'complete' objectives"], "TOPLEFT", showuseitem, "BOTTOMLEFT", GAP*2, -GAP)
  showuseitemcomplete.tiptext = L["The advanced quest tracker in the default UI will show these items.  Enable this if you would rather have Guide's button."]
  showuseitemcomplete:SetScript("OnClick", function(self) checksound(self); Guide.db.char.showuseitemcomplete = not Guide.db.char.showuseitemcomplete; Guide:UpdateStatusFrame() end)
  showuseitemcomplete:SetChecked(Guide.db.char.showuseitemcomplete)
  if Guide.db.char.showuseitem then
    showuseitemcomplete:Enable()
    showuseitemcompletelabel:SetFontObject(GameFontHighlight)
  else
    showuseitemcomplete:Disable()
    showuseitemcompletelabel:SetFontObject(GameFontDisable)
  end
	]]

  showuseitem:SetScript("OnClick", function(self)
    checksound(self)
    Guide.db.char.showuseitem = not Guide.db.char.showuseitem
    Guide:UpdateStatusFrame()
		--[[
    if Guide.db.char.showuseitem then
      showuseitemcomplete:Enable()
      showuseitemcompletelabel:SetFontObject(GameFontHighlight)
    else
      showuseitemcomplete:Disable()
      showuseitemcompletelabel:SetFontObject(GameFontDisable)
    end
		--]]
  end)


  local mapnotecoords = tekcheck.new(frame, nil, L["Map note coords with ManaArrow"], "TOPLEFT", showuseitem, "BOTTOMLEFT", 0, -GAP)
  mapnotecoords.tiptext = L["Map coordinates found in guide step notes. Provides a waypoint on the Minimap and World Map and a waypoint arrow."]
  mapnotecoords:SetChecked(Guide.db.char.mapnotecoords)
	
	local usetomtom, usetomtomlabel = tekcheck.new(frame, nil, L["Use TomTom instead"], "TOPLEFT", mapnotecoords, "BOTTOMLEFT", GAP*2, -GAP)
  usetomtom.tiptext = L["Send waypoints to TomTom for mapping instead of using ManaArrow."]
  usetomtom:SetScript("OnClick", function(self) checksound(self); Guide.db.char.usetomtom = not Guide.db.char.usetomtom; Guide:UpdateStatusFrame() end)
  usetomtom:SetChecked(Guide.db.char.usetomtom)
  if Guide.db.char.mapnotecoords and TomTom then
    usetomtom:Enable()
    usetomtomlabel:SetFontObject(GameFontHighlight)
  else
    usetomtom:Disable()
    usetomtomlabel:SetFontObject(GameFontDisable)
  end
	
	mapnotecoords:SetScript("OnClick", function(self)
		checksound(self)
		Guide.db.char.mapnotecoords = not Guide.db.char.mapnotecoords
		Guide:UpdateStatusFrame()
		if Guide.db.char.mapnotecoords and TomTom then
			usetomtom:Enable()
			usetomtomlabel:SetFontObject(GameFontHighlight)
		else
			usetomtom:Disable()
			usetomtomlabel:SetFontObject(GameFontDisable)
		end
	end)

  local mapquestgivers = tekcheck.new(frame, nil, L["Automatically map questgivers"], "TOPLEFT", usetomtom, "BOTTOMLEFT", -GAP*2, -GAP)
  mapquestgivers.tiptext = L["Automatically map questgivers for accept and turnin objectives (requires LightHeaded)."]
  mapquestgivers:SetChecked(Guide.db.char.mapquestgivers)

  local mapquestgivernotes, mapquestgivernoteslabel = tekcheck.new(frame, nil, L["Always map coords from notes"], "TOPLEFT", mapquestgivers, "BOTTOMLEFT", GAP*2, -GAP)
  mapquestgivernotes.tiptext = L["Map note coords even when LightHeaded provides coords."]
  mapquestgivernotes:SetScript("OnClick", function(self) checksound(self); Guide.db.char.alwaysmapnotecoords = not Guide.db.char.alwaysmapnotecoords end)
  mapquestgivernotes:SetChecked(Guide.db.char.alwaysmapnotecoords)
  if Guide.db.char.mapquestgivers then
    mapquestgivernotes:Enable()
    mapquestgivernoteslabel:SetFontObject(GameFontHighlight)
  else
    mapquestgivernotes:Disable()
    mapquestgivernoteslabel:SetFontObject(GameFontDisable)
  end

  mapquestgivers:SetScript("OnClick", function(self)
    checksound(self)
    Guide.db.char.mapquestgivers = not Guide.db.char.mapquestgivers
    if Guide.db.char.mapquestgivers then
      mapquestgivernotes:Enable()
      mapquestgivernoteslabel:SetFontObject(GameFontHighlight)
    else
      mapquestgivernotes:Disable()
      mapquestgivernoteslabel:SetFontObject(GameFontDisable)
    end
  end)
  
  local antsenabled, antsenabledlabel = tekcheck.new(frame,nil, "Enable map ants", "TOPLEFT", mapquestgivernotes, "BOTTOMLEFT", -GAP*2, -GAP)
	antsenabled:SetChecked(ns.dbpc.enableants == true)
	antsenabled:SetScript("OnClick", function(self)
		ns.dbpc.enableants = not(ns.dbpc.enableants)
	end)
	
  local alternative_spec = tekcheck.new(frame, nil, "Use secondary specialization with talent helper", "TOPLEFT", antsenabled, "BOTTOMLEFT", 0, -GAP)
  alternative_spec:SetChecked(ns.dbpc.talents_specialization == 2)
  alternative_spec:SetScript("OnClick", function(self) 
    ns.dbpc.talents_specialization = ns.dbpc.talents_specialization == 1 and 2 or 1
  end)

  frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)


----------------------------
--      LDB Launcher      --
----------------------------

local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local dataobj = ldb:GetDataObjectByName("GuideLauncher") or ldb:NewDataObject("GuideLauncher", {type = "launcher", icon = "Interface\\Icons\\Ability_Hunter_Pathfinding", tocname = "Guide"})
dataobj.OnClick = function() InterfaceOptionsFrame_OpenToCategory(frame) end
