﻿local AddonName,ns = ...

local MAX_LEVEL = 90 --Update this for new expantions!
local myfaction = UnitFactionGroup("player")
local L = GUIDE_LOCALE
GUIDE_LOCALE = nil

Guide = DongleStub("Dongle-1.2"):New("Guide")
if tekDebug then Guide:EnableDebug(10, tekDebug:GetFrame("Guide")) end
Guide.guides = {}
Guide.guidelist = {}
Guide.nextzones = {}
Guide.Locale = L

Guide.start_guides = {Dwarf    = "Booster Dwarf (1-12)",
Gnome    = "Booster Gnome (1-12)",
Draenei  = "Booster Draenei (1-12)",
Human    = "Booster Human (1-12)",
NightElf = "Booster NightElf (1-12)",
BloodElf = "Booster BloodElf (1-12)",
Orc      = "Booster Orc (1-12)",
Troll    = "Booster Troll (1-12)",
Tauren   = "Booster Tauren (1-12)",
Scourge   = "Booster Undead (1-12)",
Goblin   = "Booster Goblin (1-12)",
Worgen   = "Booster Worgen (1-12)",
Pandaren = "Booster Pandaren (1-12)"}

Guide.icons = setmetatable({
  ACCEPT = "Interface\\GossipFrame\\AvailableQuestIcon",
  COMPLETE = "Interface\\Icons\\Ability_DualWield",
  TURNIN = "Interface\\GossipFrame\\ActiveQuestIcon",
  KILL = "Interface\\Icons\\Ability_Creature_Cursed_02",
  RUN = "Interface\\Icons\\Ability_Tracking",
  MAP = "Interface\\Icons\\Ability_Spy",
  FLY = "Interface\\Icons\\Ability_Druid_FlightForm",
  SETHEARTH = "Interface\\AddOns\\ManaCore\\Components\\Guide\\resting.tga",
  HEARTH = "Interface\\Icons\\INV_Misc_Rune_01",
  NOTE = "Interface\\Icons\\INV_Misc_Note_01",
  USE = "Interface\\Icons\\INV_Misc_Bag_08",
  BUY = "Interface\\Icons\\INV_Misc_Coin_01",
  BOAT = "Interface\\Icons\\Spell_Frost_SummonWaterElemental",
  GETFLIGHTPOINT = "Interface\\Icons\\Ability_Hunter_EagleEye",
}, {__index = function() return "Interface\\Icons\\INV_Misc_QuestionMark" end})


function Guide:Initialize()
  self.db = self:InitializeDB("BOOSTER_GuideAlphaDB", {
    char = {
      hearth = "Unknown",
      turnedin = {},
      turnins = {},
      cachedturnins = {},
      trackquests = true,
      completion = {},
      currentguide = "No Guide",
      mapquestgivers = true,
      mapnotecoords = true,
      alwaysmapnotecoords = false,
      showstatusframe = true,
      showuseitem = true,
      showuseitemcomplete = true,
    },
  })
  if self.db.char.turnedin then self.db.char.turnedin = nil end -- Purge old table if present
  self.cachedturnins = self.db.char.cachedturnins


  LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Guide", {
    type = "launcher",
    icon = "Interface\\Icons\\Ability_Rogue_Sprint",
    OnClick = function() InterfaceOptionsFrame_OpenToCategory(Guide.configpanel) end,
  })
end


function Guide:Enable()
  self.Enable = nil -- Dongle likes to call Enable multiple times if we bug LightHeaded... so we need to nil out to ensure we are only called once
  -- if TomTom and TomTom.version ~= "SVN" and (tonumber(TomTom.version) or 0) < 120 then self:Print("Your version of TomTom is out of date.  Guide waypoints may not work correctly.") end
  self.db.char.currentguide = self.db.char.currentguide or self.guidelist[1]
  if self.guides[self.db.char.currentguide] then
    self:LoadGuide(self.db.char.currentguide)
  else
    local guidenotloaded = self.db.char.currentguide
    local orig = self.Disable
    function self:Disable(...)
      if not self.db.char.currentguide then self.db.char.currentguide = guidenotloaded end
      return orig(...)
    end

    function self:ADDON_LOADED()
      if not self.guides[guidenotloaded] then return end
      self:LoadGuide(guidenotloaded)
      self:UpdateStatusFrame()
      self:UpdateGuidesPanel()
      self:UnregisterEvent("ADDON_LOADED")
      self.ADDON_LOADED = nil
      self.Disable = orig
    end
    self:RegisterEvent("ADDON_LOADED")
	
    self:LoadGuide(self.guidelist[1])
  end
	  self:PositionStatusFrame()
	  self:PositionItemFrame()

  for _,event in pairs(self.TrackEvents) do self:RegisterEvent(event) end
  self:RegisterEvent("QUEST_COMPLETE", "UpdateStatusFrame")
  self:RegisterEvent("QUEST_DETAIL", "UpdateStatusFrame")
  self.TrackEvents = nil
  self:QuestID_QUEST_LOG_UPDATE()
  self:UpdateStatusFrame()
  if self.db.char.currentguide == "No Guide" and UnitLevel("player") < MAX_LEVEL and ns:GetCore('Booster') then
    StaticPopup_Show ("BoosterFindGuide");
  end
  --Booster:StepChanged()
end


function Guide:RegisterGuide(name, nextzone, faction, sequencefunc)
  if faction and faction ~= myfaction then return end
  self.guides[name] = sequencefunc
  self.nextzones[name] = nextzone
  table.insert(self.guidelist, name)
end


function Guide:LoadNextGuide()
  self:LoadGuide(self.nextzones[self.db.char.currentguide] or "No Guide", true)
  self:UpdateGuidesPanel()
  return true
end


local firstcall = true
function Guide:GetQuestLogIndexByName(name)
  name = name or self.quests[self.current]
  name = name:gsub(L.PART_GSUB, "")
  for i=1,GetNumQuestLogEntries() do
    local title, _, _, _, isHeader = GetQuestLogTitle(i)
    if firstcall and not isHeader then
      firstcall = nil
      if string.sub(title, 1, 1) == "[" then self:Print("Another addon, most likely a \"Quest Level\" addon, is preventing Guide's quest detection from working correctly.") end
    end
    if not isHeader and title == name then return i end
  end
end


function Guide:GetQuestLogIndexByQID(qid)
  for i=1,GetNumQuestLogEntries() do
    local link = GetQuestLink(i)
    local thisqid = link and self.QIDmemo[link]
    if thisqid and qid == thisqid then return i end
  end
end


function Guide:GetQuestDetails(name, qid)
  if not name then return end

  local i = qid and self:GetQuestLogIndexByQID(qid) or self:GetQuestLogIndexByName(name)
  local complete = i and select(7, GetQuestLogTitle(i)) == 1
  return i, complete
end


function Guide:FindBagSlot(itemid)
  for bag=0,4 do
    for slot=1,GetContainerNumSlots(bag) do
      local item = GetContainerItemLink(bag, slot)
      if item and string.find(item, "item:"..itemid) then return bag, slot end
    end
  end
end


function Guide:GetObjectiveInfo(i)
  i = i or self.current
  if not self.actions[i] then return end

  return self.actions[i], self.quests[i]:gsub("@.*@", ""), self.quests[i] -- Action, display name, full name
end


function Guide:GetObjectiveStatus(i)
  i = i or self.current
  if not self.actions[i] then return end

  local qid = self:GetObjectiveTag("QID", i)

  return qid and self.turnedinquests[qid] or self.turnedin[self.quests[i]], self:GetQuestDetails(self.quests[i], qid) -- turnedin, logi, complete
end


function Guide:SetTurnedIn(i, value, noupdate)
  if not i then
    i, value = self.current, true
  else
    value = not not value -- Cleanup to minimize savedvar data
  end

  local qid = self:GetObjectiveTag("QID", i)

  if qid and not self:GetObjectiveTag("L", i) then self.turnedinquests[qid] = value end
  self.turnedin[self.quests[i]] = value
  self:DebugF(1, "Set turned in %q = %s", self.quests[i], tostring(value))
  if not noupdate then self:UpdateStatusFrame()
  else self.updatedelay = i end
end


function Guide:CompleteQuest(name)
  if not self.current then
    self:DebugF(1, "Cannot complete %q, no guide loaded", name)
    return
  end

  local i = self.current
  local action, quest
  repeat
    action, quest = self:GetObjectiveInfo(i)
    if action == "TURNIN" and not self:GetObjectiveStatus(i) and name == quest:gsub(L.PART_GSUB, "") then
      self:DebugF(1, "Saving quest turnin %q", quest)
      return self:SetTurnedIn(i, true, true)
    end
    i = i + 1
  until not action
  self:DebugF(1, "Quest %q not found!", name)
end


---------------------------------
--      Utility Functions      --
---------------------------------

function Guide.ColorGradient(perc)
  if perc >= 1 then return 0,1,0
  elseif perc <= 0 then return 1,0,0 end

  local segment, relperc = math.modf(perc*2)
  local r1, g1, b1, r2, g2, b2 = select((segment*3)+1, 1,0,0, 1,0.82,0, 0,1,0)
  return r1 + (r2-r1)*relperc, g1 + (g2-g1)*relperc, b1 + (b2-b1)*relperc
end


function Guide:DumpLoc()
  if IsShiftKeyDown() then
    if not self.db.global.savedpoints then self:Print("No saved points")
    else for t in string.gmatch(self.db.global.savedpoints, "([^\n]+)") do self:Print(t) end end
  elseif IsControlKeyDown() then
    self.db.global.savedpoints = nil
    self:Print("Saved points cleared")
  else
    local _, _, x, y = DongleStub("Astrolabe-1.0"):GetCurrentPlayerPosition()
    local s = string.format("%s, %s, (%.2f, %.2f) -- %s %s", GetZoneText(), GetSubZoneText(), x*100, y*100, self:GetObjectiveInfo())
    self.db.global.savedpoints = (self.db.global.savedpoints or "") .. s .. "\n"
    self:Print(s)
  end
end
