


local Guide = Guide
local texture, item
local _,ns = ...
local useageTooltipText = "\n\nThis is an item to be used for this quest.\nLeft Click the Item to use it.\n\nLeft Click and drag to move this box. \nControl Right Click this box to put it\nback above the Ring.\n\nTo Lock or Unlock the box\nJust hold Shift and Right Click it."
local isLocked

local frame = CreateFrame("Button", "GuideItemFrame", UIParent, "SecureActionButtonTemplate")
frame:SetFrameStrata("LOW")
frame:SetHeight(36)
frame:SetWidth(36)
frame:SetPoint("BOTTOMRIGHT", MinimapCluster, "BOTTOMRIGHT", -192-62, -192+20)
frame:Hide()

local function setPosToRing()
	frame:ClearAllPoints()
	frame:SetPoint('BOTTOM',ns:GetModule('RingUI').Ring,'TOP', 0, 30)
	BoosterItemButtonLabel:Hide()
end

local function toggleFrameLock()
	if (IsAddOnLoaded("Booster")) then
		if isLocked then
			UIErrorsFrame:AddMessage("Booster's Quest Item Button is Unlocked.", 1.0, 0.0, 0.0, 53, 3)
			isLocked = false
			frame:RegisterForDrag("LeftButton")
			frame:SetMovable(true)
			frame:SetClampedToScreen(true)
			frame:SetScript("OnDragStart", frame.StartMoving)
			frame:SetScript("OnDragStop", function(frame)
				frame:StopMovingOrSizing()
				Guide.db.profile.itemframepoint, Guide.db.profile.itemframex, Guide.db.profile.itemframey = Guide.GetUIParentAnchor(frame)
				BoosterItemButtonLabel:Show()
				Guide:Debug(1, "Item frame moved", Guide.db.profile.itemframepoint, Guide.db.profile.itemframex, Guide.db.profile.itemframey)
			end)
		else
			isLocked = true
			UIErrorsFrame:AddMessage("Booster's Quest Item Button is Locked.", 1.0, 0.0, 0.0, 53, 3)
			frame:RegisterForDrag()
			frame:SetMovable(false)
			frame:SetClampedToScreen(false)
		end
	end
end

local checkTooltip = function(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("BOTTOMRIGHT", frame, "TOPLEFT")
	GameTooltip:SetItemByID(item)
	GameTooltip:AddLine(useageTooltipText)
	GameTooltip:Show()
end

BoosterItemButtonLabel = frame:CreateFontString()
BoosterItemButtonLabel:SetPoint("TOP", frame, "BOTTOM")
BoosterItemButtonLabel:SetFontObject(GameFontNormal)
BoosterItemButtonLabel:SetText("Booster Use Quest\n Item Button")

local cooldown = CreateFrame("Cooldown", nil, frame)
cooldown:SetAllPoints(frame)
cooldown:Hide()
	
local function RefreshCooldown()
	if not item or not frame:IsVisible() then return end
	local start, duration, enabled = GetItemCooldown(item)
	if enabled then
		cooldown:Show()
		cooldown:SetCooldown(start, duration)
	else cooldown:Hide() end
end
cooldown:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
cooldown:SetScript("OnEvent", RefreshCooldown)
frame:SetScript("OnShow", RefreshCooldown)


local itemicon = frame:CreateTexture(nil, "ARTWORK")
itemicon:SetWidth(24) itemicon:SetHeight(24)
itemicon:SetTexture("Interface\\Icons\\INV_Misc_Bag_08")
itemicon:SetAllPoints(frame)


frame:RegisterForClicks("anyUp")
frame:HookScript("OnClick", function(self, button) 
	if Guide:GetObjectiveInfo() == "USE" then Guide:SetTurnedIn() end
	if (button == "RightButton") and IsControlKeyDown() then setPosToRing() end
	if (button == "RightButton") and IsShiftKeyDown() then toggleFrameLock() end
end)


local function PLAYER_REGEN_ENABLED(self)
	if texture then
		itemicon:SetTexture(texture)
		frame:SetAttribute("type1", "item")
		frame:SetAttribute("item1", "item:"..item)
		frame:Show()
		texture = nil
	else
		frame:SetAttribute("item1", nil)
		frame:Hide()
	end
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
end
frame:SetScript("OnEvent", PLAYER_REGEN_ENABLED)


function Guide:SetUseItem(tex, use)
	texture, item = tex, use
	if InCombatLockdown() then frame:RegisterEvent("PLAYER_REGEN_ENABLED") else PLAYER_REGEN_ENABLED(frame) end
end


toggleFrameLock()
frame:SetScript("OnEnter", checkTooltip)
frame:SetScript("OnLeave", function () GameTooltip:Hide() end)


function Guide:PositionItemFrame()
	frame:ClearAllPoints()
	local pt, x, y = self.db.profile.itemframepoint, self.db.profile.itemframex, self.db.profile.itemframey
	if pt and x and y then frame:SetPoint(pt or "BOTTOMRIGHT", pt and UIParent or MinimapCluster, pt or "BOTTOMRIGHT", x or -254, y or -172) else
		setPosToRing()
	end
end