﻿local _,ns = ...

if HEXIBOOSTER_DONT_LOAD_GUIDE then return end
local L = Guide.Locale
local MapData = LibStub("LibMapData-1.0");
local Astrolabe = DongleStub("Astrolabe-1.0")

-- Special area translations
local zonei = {
	--["Plaguelands: The Scarlet Enclave"] = 1,
	--["Gilneas City"] = 1,
	--["Gilneas"] = 1,
}
MC_ZONEI = zonei

local zonec = {
	--["Plaguelands: The Scarlet Enclave"] = -77,
	--["Gilneas City"] = -78,
	--["Gilneas"] = -79,
}
MC_ZONEC = zonec
	
local zonenames = {
	--[-77] = {"Plaguelands: The Scarlet Enclave"},
	--[-78] = {"Gilneas City"},
	--[-79] = {"Gilneas"},
}
MC_ZONEN = zonenames

for ci,c in pairs{GetMapContinents()} do
	zonenames[ci] = {GetMapZones(ci)}
	for zi,z in pairs(zonenames[ci]) do
		zonei[z], zonec[z] = zi, ci
	end
end

local cache = {}
local onarrive = {}

local first_time = true
local first_point 

local delay, timer = CreateFrame("Frame"), 0
delay:Hide()

--NOTE: Depreciated
local m,i = ns:RegisterModule()
m:RegisterEvent('TOMTOM_WAYPOINT_REACHED')
m.TOMTOM_WAYPOINT_REACHED = function (active_point)
	if onarrive[active_point] and (Guide.current == onarrive[active_point][1]) and (Guide.db.char.currentguide == onarrive[active_point][2]) then
		Guide:SetTurnedIn(onarrive[active_point][1],true)
		onarrive[active_point] = nil
	end
end

local function MapPoint(mapNameOrId, x, y, desc)
	if(ns.vars.dungeon_mode)then return end;
	--if first_time then
		--first_point = {zone, x, y, desc, c, z}
		--delay:Show()
		--return
	--end
	Guide:DebugF(1, "Mapping %q - %s (%.2f, %.2f)", desc, mapNameOrId, x, y)
	ns:debug("Mapping", desc, mapNameOrId, x, y)
	--local zi, zc = z or zone and zonei[zone] or zonei[GetRealZoneText()], c or zone and zonec[zone] or zonec[GetRealZoneText()]
	--print(zone, x, y, desc, c, z, zi, zc)
	--if not zi then
		--if zone then Guide:PrintF(L["Cannot find zone %q, using current zone."], zone)
		--else Guide:Print(L["No zone provided, using current zone."]) end
		--zi, zc = GetCurrentMapZone(), GetCurrentMapContinent()
	--end
	
	--zone = zone or zonenames[zc][zi]
	local m, f
	if type(tonumber(mapNameOrId)) == "number" then
		m = tonumber(mapNameOrId)
	else
		local zc, zi = zonec[mapNameOrId], zonei[mapNameOrId]
		if zi and zc then
			m = Astrolabe:GetMapID(zc, zi) --this is a dirty fix until we can get all guides transitioned
		end
		if not m then
			m = tonumber(MapData:MapAreaId(mapNameOrId))
		end
	end
	
	if not m then
		ns:debug("Failed to find map ID", mapNameOrId or "", desc)
		return
	end
	
	f = MapData:MapFloors(m) --this needs work, we want to be able to specify floors
	if mapNameOrId == "Orgrimmar" or mapNameOrId == "321" or f > 1 then --MapData out of date for Org
		f = 1
	end
	
	if not f then
		ns:debug("Failed to get a valid floor", mapNameOrId or "", desc)
		return
	end
		
	ns.Ants:SetMFPoint(m, f, x/100, y/100)
	
	if TomTom and Guide.db.char.usetomtom then
		--ns.Ants:addPoint(zc,zi,x,y,desc)
		--local ui_res = TomTom:AddZWaypoint(zc, zi, x, y, desc, false,true,true)
		ns:debug("Mapping to TomTom", m, f, x/100, y/100)
		local ui_res = TomTom:AddMFWaypoint(m, f, x/100, y/100, {
        title = desc,
        persistent = false,
				cleardistance = 0,
				arrivaldistance = 5,
        minimap = true,
        world = true,
        --callbacks = callbacks,
        --silent = silent,
        --crazy = crazy,
    	}
		)
		if(ui_res) then
			table.insert(cache,ui_res)
			local action = Guide:GetObjectiveInfo()
			if (action == 'FLY') or (action == 'RUN') then
				onarrive[ui_res] = {Guide.current, Guide.db.char.currentguide}
			end
		end
	--[[--not ready for m, f method anyway
	elseif Cartographer_Waypoints then --This is currently broken in new map scheme
		local pt = NotePoint:new(zone, x/100, y/100, desc)
		Cartographer_Waypoints:AddWaypoint(pt)
		table.insert(cache, pt.WaypointID)
	--]]
	elseif ManaArrow then
		ns:debug("Mapping to ManaArrow", m, f, x/100, y/100)
		ManaArrow:SetMFPoint(m, f, x/100, y/100, desc)
	end
end

delay:SetScript("OnUpdate", function(x, last)
	timer = timer + last
	if timer < 3 then return end
	first_time = false
	delay:SetScript("OnUpdate",nil)
	delay:Hide()
	timer = 0
	MapPoint(unpack(first_point))
end)

local temp = {}
function Guide:ParseAndMapCoords(action, quest, zone, note, qid)
	if TomTom and TomTom.RemoveWaypoint then
		while cache[1] do TomTom:RemoveWaypoint(table.remove(cache)) end
	--[[
		elseif Cartographer_Waypoints then
		while cache[1] do Cartographer_Waypoints:CancelWaypoint(table.remove(cache)) end
	--]]
	end
	
	ns.Ants:ClearPoint()
	ManaArrow:ClearPoint()
	
	if not(note and self.db.char.mapnotecoords) then
		return
	end
	
	--ns.Ants:removePoint()

	--if (action == "ACCEPT" or action == "TURNIN") and LightHeaded and self:MapLightHeadedNPC(qid, action, quest) and not self.db.alwaysmapnotecoords
	--or not (note and self.db.char.mapnotecoords) then return end

	for x,y in note:gmatch(L.COORD_MATCH) do table.insert(temp, tonumber(y)); table.insert(temp, tonumber(x)) end
	while temp[1] do MapPoint(zone, table.remove(temp), table.remove(temp), quest) end
end


function Guide:MapLightHeadedNPC(qid, action, quest)
	if not self.db.char.mapquestgivers then return end
	if not LightHeaded then return end

	local npcid, npcname, stype
	if action == "ACCEPT" then _, _, _, _, stype, npcname, npcid = LightHeaded:GetQuestInfo(qid)
	else _, _, _, _, _, _, _, stype, npcname, npcid = LightHeaded:GetQuestInfo(qid) end
	self:Debug(1, "LightHeaded lookup", action, qid, stype, npcname, npcid)
	if stype ~= "npc" then return end

	local data = LightHeaded:LoadNPCData(tonumber(npcid))
	if not data then return end
	for zid,x,y in data:gmatch("([^,]+),([^,]+),([^:]+):") do 
		MapPoint(tonumber(zid), tonumber(x), tonumber(y), quest.." ("..npcname..")") 
	end
	return true
end
