﻿local _,ns = ...
ns.xp_tracker = {}
local xp = ns.xp_tracker
xp.frame = CreateFrame("Frame")
local start, start_xp, last_xp = nil, 0, 0
local additional_xp = 0 -- in case of levelup

function xp:reset()
  start, start_xp = nil, nil
  self:update()
end

function xp:update()
  local xp_hour = 0
  if start then
    local elapsed = time() - start
    local earned  = additional_xp + last_xp - start_xp
    xp_hour = earned * 3600.0/elapsed
  end
  ns.info_label:SetText(string.format('%.1fk XP/h',xp_hour/1000.0))
end

xp.frame:RegisterEvent("PLAYER_XP_UPDATE")
xp.frame:RegisterEvent("PLAYER_LEVEL_UP")
xp.frame:SetScript("OnEvent", function(self, event, arg1)
  if event == "PLAYER_LEVEL_UP" then
    local x = UnitXP("player")
    additional_xp = additional_xp + x > last_xp and x or last_xp
  else
    if arg1 == 'player' then 
      last_xp = UnitXP("player")
      if not start then 
        start = time()
        start_xp = last_xp
      else
        xp:update()
      end
    end
  end
end)

local next_update = 0
xp.frame:SetScript("OnUpdate", function()
  if next_update < time() then 
    next_update = time() + 10
    xp:update() 
  end
end)