﻿local AddonName, ns = ...;
local m = ns:GetModule("MapMarker");

--NOTE: Documentation possibly Out Of Date
--[[
	How Worldmap marking works:

		1. The worldmap marker firstly creates 2 tables: worldmapFrames, and MapMarker.activeWorldmapRoutes
			* Each entry in worldmapFrames is a frame with the worldmap route drawn on it and dimensions equal to WorldMapButton.
				Since the frames are the same size as WorldMapButton, if the worldmap gets resized or moved or whatever, then the
				frames will also.
			* Each entry in MapMarker.activeWorldmapRoutes is a zone[route] that should be displayed on the worldmap when in the
				appropriate zone. Every time it's called, MapMarker.updateWorldmapRoutes() checks the current zone
				against MapMarker.activeWorldmapRoutes's zonelist, and calls :Show() and updates the position of each frame in
				worldmapFrames that is also in MapMarker.activeWorldmapRoutes

		2. After creating those two tables, whenever a MapMarker.drawWorldmapLines(...) is invoked, it creates or
			shows (whichever is more appropriate) the frame for the input route for the input zone.

		3. WorldmapFrames are then kept current by MapMarker.updateWorldmapRoutes, which shows and hides Worldmap Frames 
			as appropriate for the zone the player is in.
			
		NOTE:
			MapMarker.worldmapframe does not use OnUpdate. The only event it needs is WORLD_MAP_UPDATE
]]--
--local worldmapFrames = {};
--MapMarker.activeWorldmapRoutes = {};
local WORLDMAP_LINES = {};
local USED_WORLDMAP = {};
local activezoneid;
local activeroute;
local overlay = CreateFrame("Frame", nil, WorldMapButton);
overlay:Hide();
overlay:SetAllPoints(WorldMapButton);
local visiblebefore = false;

--local function declaration
local updateLines;

--used for updates, regardless of if overlay is shown
local throttle = CreateFrame("Frame", nil, WorldMapButton); 
throttle:Show()
throttle:SetScript("OnUpdate",function()
	MapMarker.updateWorldmapRoutes();
end);

--TODO: find a better event to fire this off of then every update
--At least it only fires when world map is visible
function MapMarker.updateWorldmapRoutes()
	local current_zoneid = GetCurrentMapAreaID();
	if ((not overlay:IsShown()) and current_zoneid == activezoneid) then
		overlay:Show()
		updateLines()
	elseif (overlay:IsShown() and current_zoneid ~= activezoneid) then
		overlay:Hide()
	end
	
	--redraw the lines when the overlay is visible for the first
	--time to get around invalid size issues
	if overlay:IsVisible() and not visiblebefore then 
			MapMarker:mdebug("MapMarker redrawing for first visible")
			updateLines()
			visiblebefore = true;
	end
end

-- Hides the worldmap frame for the input zone with the input routeName
function MapMarker.hideWorldmapRoute(zone, routeName)
	activezoneid = nil;
	activeroute = nil;
	MapMarker.undrawLine(overlay, WORLDMAP_LINES, USED_WORLDMAP);
end

-- draws the input route on the worldmap
-- 	not really, what it actually does is it draws the input route on a frame and then overlays that atop the worldmap. The other way is easier to say though
function MapMarker.drawWorldmapLines(zoneid, route)
	activezoneid = zoneid;
	activeroute = route;
	
	overlay:Hide()
	MapMarker.updateWorldmapRoutes();
end

updateLines = function()
	-- release the previous lines
	MapMarker.undrawLine(overlay, WORLDMAP_LINES, USED_WORLDMAP);
	
	-- draw the route on the frame
	local start_point, end_point;
	end_point = { MapMarker.decodeCoord(activeroute[#activeroute]) }; -- starts at the end, to make a looped route

	for index, coords in pairs(activeroute) do
		start_point = { MapMarker.decodeCoord(coords) };
		--TODO: add type to route files, or use required profession to color route
		MapMarker.drawLine(overlay, WORLDMAP_LINES, USED_WORLDMAP, start_point[1], 1-start_point[2], end_point[1], 1-end_point[2], MapMarker.getColor({"Herb"}));
		end_point = start_point;
	end
end