﻿local _,ns = ...
local m,i = ns:RegisterModule(nil,'DungeonMode')
local frame = CreateFrame('Frame',nil,UIParent)

local frames = {
	--TomTomCrazyArrow = 'UIParent',
	--TomTomMapOverlay = 'WorldMapButton',
	--BoosterMapOverlay = 'WorldMapDetailFrame',
	--ManaCoreMapOverlay = 'WorldMapDetailFrame',
	GuideStatusFrame = 'UIParent',
}

local enableDungeonMode = function ()
	for f, parent in pairs(frames) do
		if _G[f] then _G[f]:SetParent(frame) end
	end
	--if TomTom.current and TomTom.current.minimap then TomTom.current.minimap:Hide() end
	frame:Hide()
	
	--TODO: Move this to guide mapping code that also handles removing anything active from TomTom
	ns:GetModule("ManaArrow"):ClearPoint()
end

local disableDungeonMode = function ()
	for f, parent in pairs(frames) do
		if _G[f] and _G[parent] then _G[f]:SetParent(_G[parent]) end
	end
	--if TomTom.current and TomTom.current.minimap then TomTom.current.minimap:Show() end
	frame:Show()
	
	Guide:UpdateStatusFrame()
end

m.MANACORE_VARS_CHANGED = function (self,k,old,v)
	if k == 'dungeon_mode' then
		if ns.vars[k] then enableDungeonMode() else disableDungeonMode() end
	end
end
