﻿local AddonName,ns = ...
if true then return end
local tg = Guide
local ww = WidgetWarlock
local m,i = ns:RegisterModule(nil,'GuideFrame')
m.frames = {}
local slave,i = ns:RegisterModule(nil,'GuideSlave')

m.status_right = CreateFrame("Button", "GuideStatusFrameRight", tg.statusframe)
m.status_right:SetWidth(128)
m.status_right:SetHeight(64)
m.status_right:SetPoint("LEFT", "GuideStatusFrame", "RIGHT", 0, -12)
m.status_right:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\single_right")
m.status_right:RegisterForDrag("LeftButton")
m.status_right:SetScript("OnDragStart", function()
  tg.statusframe:OnDragStart()
end)
m.status_right:SetScript("OnDragStop", function()
  tg.statusframe:OnDragStop()
end)
ns.status_right = m.status_right

m.status_left = CreateFrame("Button", "GuideStatusFrameLeft", tg.statusframe)
m.status_left:SetWidth(128)
m.status_left:SetHeight(64)
m.status_left:SetPoint("RIGHT", "GuideStatusFrame", "LEFT", 0, -12)
m.status_left:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\single_left")
m.status_left:RegisterForDrag("LeftButton")
m.status_left:SetScript("OnDragStart", function()
	tg.statusframe:OnDragStart()
end)
m.status_left:SetScript("OnDragStop", function()
	tg.statusframe:OnDragStop()
end)
ns.status_left = m.status_left

m.label = ww.SummonFontString(m.status_left, nil, "GameFontNormal", nil, "RIGHT", m.status_left, "RIGHT", -10, 9)
m.label:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
m.label:SetWidth(100)
m.label:SetTextColor(1,1,1)
m.label:SetJustifyH("RIGHT")
ns.info_label = m.label

m.status_left_off = CreateFrame("Button", "GuideStatusFrameLeftOff", tg.statusframe)
m.status_left_off:SetWidth(64)
m.status_left_off:SetHeight(64)
m.status_left_off:SetPoint("RIGHT", "GuideStatusFrame", "LEFT", 0, -12)
m.status_left_off:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\single_left_close")
ns.status_left_off = m.status_left_off

m.misc_btn_off = CreateFrame("Button", nil, m.status_left_off)
m.misc_btn_off:SetWidth(32)
m.misc_btn_off:SetHeight(32)
m.misc_btn_off:SetPoint("RIGHT", m.status_left_off, "RIGHT", -3, 9)
m.misc_btn_off:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\misc_off")
m.misc_btn_off:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\misc_off")
m.misc_btn_off:SetScript("OnClick", function(frame, button) 
  ns.db.show_xp = true
  ns.status_left:Show()
  ns.status_left_off:Hide()
end)
ns.misc_btn_off = m.misc_btn_off

m.misc_btn = CreateFrame("Button", nil, ns.status_left)
m.misc_btn:SetWidth(32)
m.misc_btn:SetHeight(32)
m.misc_btn:SetPoint("LEFT", ns.status_left, "LEFT", 32, 9)
m.misc_btn:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\misc")
m.misc_btn:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\misc")
m.misc_btn:RegisterForClicks("LeftButtonDown", "RightButtonDown")
m.misc_btn:SetScript("OnClick", function(frame, button) 
  if button == 'LeftButton' then
    ns.db.show_xp = false
    ns.status_left:Hide()
    ns.status_left_off:Show()
  else -- right button resets xp
    ns.xp_tracker:reset()
  end
end)
ns.misc_btn = m.misc_btn


m.option_frame = CreateFrame("Frame", "BoosterOptionFrame", tg.statusframe)
m.option_frame:SetHeight(1)
m.option_frame:SetWidth(170)
m.option_frame:SetPoint("TOPRIGHT", ns.status_right, "BOTTOMRIGHT", -80, 29)
m.option_frame.texture = m.option_frame:CreateTexture(nil, "BACKGROUND")
m.option_frame.texture:SetPoint("CENTER")
m.option_frame.texture:SetWidth(230)
m.option_frame.texture:SetHeight(1)
m.option_frame.texture:SetTexture(0,0,0,0)
tg.objectiveframe:SetPoint("TOPRIGHT", m.option_frame, "BOTTOMRIGHT", -55, -13)
ns.option_frame = m.option_frame

m.option_bottom = CreateFrame("Frame", "BoosterOptionFrameBottom", tg.statusframe)
m.option_bottom:SetWidth(64)
m.option_bottom:SetHeight(16)
m.option_bottom:SetPoint("TOPRIGHT", ns.option_frame, "BOTTOMRIGHT", 22, 0)
m.option_bottom.texture = m.option_bottom:CreateTexture(nil, "ARTWORK")
m.option_bottom.texture:SetTexture("Interface\\AddOns\\ManaCore\\Media\\option_bottom_small")
m.option_bottom.texture:SetPoint("TOPRIGHT")
ns.option_bottom = m.option_bottom

m.option_btn = CreateFrame("Button", "BoosterOptionPanelButton", tg.statusframe)
m.option_btn:SetWidth(32)
m.option_btn:SetHeight(32)
m.option_btn:SetFrameStrata("MEDIUM")
m.option_btn:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\option_dbutton")
m.option_btn:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\option_dbutton_hover")
m.option_btn:SetPoint("TOPLEFT", ns.option_bottom, "TOPLEFT", 10, 5)
ns.option_btn = m.option_btn

m.option_container = CreateFrame("Frame","BoosterOptionsContainer", tg.statusframe)
m.option_container:SetAllPoints(m.option_frame)

m.option_btn:SetScript("OnClick", function()
  if ns.option_btn.shown then
    ns.option_btn:Hide()
  else
    ns.option_btn:Show()
  end
  ns.lh_frame:Position()
end)

local function createButton(texture, parent, normal, size)
  local f = CreateFrame("Button", nil, parent or tg.statusframe)
  f:SetWidth(size or 32) f:SetHeight(size or 32)
  f:SetNormalTexture(texture)
  f:SetHighlightTexture(normal and texture or texture..'_hover')
  f:SetScript("OnClick", function() f:onClick() end)
  return f
end

local function addTooltip(widget, text, ...)
  widget:EnableMouse(true)
  widget:SetScript("OnEnter", function() 
    GameTooltip:SetOwner(widget, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPRIGHT", widget, "BOTTOMLEFT")
    GameTooltip:SetText(text, nil, nil, nil, nil, true)
  end)
  widget:SetScript("OnLeave", function() GameTooltip:Hide() end)
end

local maximize = createButton("Interface\\AddOns\\ManaCore\\Media\\maximize", ns.status_right)
local minimize = createButton("Interface\\AddOns\\ManaCore\\Media\\minimize", ns.option_frame)
ns.minimize = minimize
ns.maximize = maximize

maximize:SetPoint("TOPRIGHT", ns.status_right, "TOPRIGHT", -55, 0)
function maximize:onClick()
  maximize:Hide()
  minimize:Show()
  ShowUIPanel(Guide.objectiveframe)
end

minimize:SetPoint("TOPRIGHT", ns.status_right, "TOPRIGHT", -55, 0)
minimize:Hide()
function minimize:onClick()
  minimize:Hide()
  maximize:Show()
  HideUIPanel(Guide.objectiveframe)
end

local config = createButton("Interface\\AddOns\\ManaCore\\Media\\config", m.option_container)
config:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\config")
function config:onClick()
  HideUIPanel(tg.objectiveframe)
  InterfaceOptionsFrame_OpenToCategory(Guide.configpanel)
end
--[[
local options_text = ww.SummonFontString(m.option_container, nil, "GameFontNormal", nil, "LEFT", m.option_container, "LEFT", 10, 0)
options_text:SetFont("Fonts\\ARIALN.TTF", 12, "OUTLINE")
options_text:SetWidth(100)
options_text:SetTextColor(1,1,1)
options_text:SetJustifyH("LEFT")
options_text:SetText("OPTIONS")
]]--
function ns.option_btn:Hide()
  m.option_frame:SetHeight(1)
  m.option_frame.texture:SetHeight(1)
  m.option_frame.texture:SetTexture(0,0,0,0)
  m.option_btn:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\option_dbutton")
  m.option_btn:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\option_dbutton_hover")
  m.option_container:Hide()
  self.shown = false
end

function ns.option_btn:Show()
  m.option_frame:SetHeight(30)
  m.option_frame.texture:SetHeight(30)
  m.option_frame.texture:SetTexture(0,0,0,0.5)
  m.option_btn:SetNormalTexture("Interface\\AddOns\\ManaCore\\Media\\option_button")
  m.option_btn:SetHighlightTexture("Interface\\AddOns\\ManaCore\\Media\\option_button_hover")
  m.option_container:Show()
  self.shown = true
end

ns.option_btn:Hide()

local ShowOptionTooltip = function(self) 
    self.state = '|cFFFFFFFFCurrently: '..(self.proxy[self.var] == true and '|cFF00FF00On' or '|cFFFF0000Off')
    GameTooltip:SetOwner(self, "ANCHOR_NONE")
    GameTooltip:SetPoint("TOPRIGHT", self, "BOTTOMLEFT")
    GameTooltip:SetText(self.header..self.body..self.state, nil, nil, nil, nil, true)
    GameTooltip:Show()
end

local setOptionTooltip = function (var, title, text)
    local widget = m[var]
    if not widget then return end
    
    widget.header = '|cFF6666FF'..title..'\n\n'
    widget.body = '|cFFFFFFFF'..text..'\n\n'
    
    widget:EnableMouse(true)
    widget:SetScript("OnEnter", ShowOptionTooltip)
    widget:SetScript("OnLeave", function() GameTooltip:Hide() end)
    widget.ShowTooltip = ShowOptionTooltip
end

local createOption = function (var, onTex, offTex, size, customclick)
    local f = CreateFrame("Button", nil, m.option_container)
    f.var = var
    f.onTex = onTex
    f.offTex = offTex
    
    f:SetWidth(size or 32)
    f:SetHeight(size or 32)

    m[var] = f
    return f
end

local onVarChanged = function (self,var)
    local f = m[var]
    if f then
	local texture
	if f.proxy then
	    texture = f.proxy[var] == true and f.onTex or f.offTex
	else
	    texture = f.onTex
	end
	f:SetNormalTexture(texture)
	f:SetHighlightTexture(texture)

	if f:IsMouseOver() then
	    GameTooltip:Hide()
	    f:ShowTooltip()
	end
    end
end

m.SortButtons = function (self)
    table.sort(self.frames, function (a,b) return a.position < b.position end)
    for i,frame in ipairs(self.frames) do
	if i == 1 then
	    frame:SetPoint("RIGHT", m.option_container, "RIGHT", -5, 0)
	else
	    frame:SetPoint("RIGHT", self.frames[i-1], "LEFT")
	end
    end
    --m.option_frame:SetPoint('LEFT',m.frames[#m.frames],'LEFT')
end

local SetButtonAttributes = function (self, var, core, changedEvent, readyEvent, position, onTex, offTex, title, text, customclick)
    local f = createOption(var,onTex,offTex,size)
    f.position = position
    if changedEvent or readyEvent then
	local e = changedEvent or readyEvent
	f.proxy = ns.RegisteredCores[core].DBEvents[e]
    end
    table.insert(m.frames,f)

    f.changedEvent = changedEvent
    f.readyEvent = readyEvent
    
    f.SetTooltip = function (self,title,text) setOptionTooltip(f.var,title,text) end
    if title and text then f:SetTooltip(title,text) end
    
    f.Initialize = function (self)
	onVarChanged(m,var)
	
	if type(customclick)=='function' then
	    self:SetScript("OnClick", customclick)
	else
	    self:SetScript("OnClick", function()
		self.proxy[var] = not(self.proxy[var])
	    end)
	end
	m:SortButtons()
	f.Initialize = nil
	return self -- make sure we're always returning a frame ref, just in case.
    end

    if changedEvent then
	slave[changedEvent] = onVarChanged
	slave:RegisterEvent(changedEvent)
    end
    if readyEvent then
	slave[readyEvent] = function ()
	    for i,f in pairs(m.frames) do
		if f.readyEvent == readyEvent then f:Initialize() end
	    end
	end
	slave:RegisterEvent(readyEvent)
    else
	f:Initialize()
    end
    return f
end

m.RegisterButton = function (self, var, core, changedEvent, readyEvent, position, onTex, offTex, title, text, customclick)
    if ns:GetCore(core) then
	SetButtonAttributes(self, var, core, changedEvent, readyEvent, position, onTex, offTex, title, text, customclick)
    else
	if readyEvent then
	    local d,id = ns:RegisterModule()
	    d.Events[readyEvent] = function (self)
		SetButtonAttributes(self, var, core, changedEvent, readyEvent, position, onTex, offTex, title, text, customclick)
		self = nil -- Yes, it's THAT MUCH of a hack.
	    end
	end
    end
end

m.MANACORE_CFG_READY = function (self)
    addTooltip(m.showconfig, "|cFF6666FFOpen Booster configuration")
    addTooltip(m.misc_btn_off, "Click to show the XP/hour counter.")
    addTooltip(m.misc_btn, "Left-Click to hide the XP/hour counter.\nRight-Click to reset the counter.")
    
    if ns.db.show_xp == true then		
	m.status_left:Show()
	m.status_left_off:Hide()
    else
	ns.status_left:Hide()
	ns.status_left_off:Show()
    end
end

-- Priorities are set in multiples of 10 to make adding buttons later easy.
do
    m:RegisterButton("lock_frame", "ManaCore", "MANACORE_CFG_CHANGED", "MANACORE_CFG_READY", 10,
	"Interface\\AddOns\\ManaCore\\Media\\locked", "Interface\\AddOns\\ManaCore\\Media\\unlocked",
	"Lock","Lock the status window to its current position.")
    m:RegisterButton("show_comments", "ManaCore", "MANACORE_CFG_CHANGED", "MANACORE_CFG_READY", 20,
	"Interface\\AddOns\\ManaCore\\Media\\comments_on", "Interface\\AddOns\\ManaCore\\Media\\comments_off",
	"Wowhead Comments", "Automatically show Wowhead comments for each quest step, without needing to press the 'Show comments' button.")
    m:RegisterButton("talentsAuto", "Booster", "BOOSTER_CFG_CHANGED", "BOOSTER_CFG_READY", 30,
	"Interface\\AddOns\\ManaCore\\Media\\talents_on","Interface\\AddOns\\ManaCore\\Media\\talents_off",
	"Auto Assign Talent Points","Automatically spend talent points for the spec you have chosen each level.\n\n|cFFFF0000WARNING: This may result in respec fees if you wish to use a spec that is different from what Booster recommends.")
    m:RegisterButton("show_muleshop", "ManaCore", "MANACORE_VARS_CHANGED", nil, 40,
	"Interface\\AddOns\\ManaCore\\Media\\muleshopper_open", "Interface\\AddOns\\ManaCore\\Media\\muleshopper_open_off",
	"Mule Shopper","Open/Close the Mule Shopper window.")
    m:RegisterButton("showconfig", "ManaCore", nil, nil, 50,
	"Interface\\AddOns\\ManaCore\\Media\\config", "Interface\\AddOns\\ManaCore\\Media\\config",
	nil, nil,
	function () HideUIPanel(tg.objectiveframe); InterfaceOptionsFrame_OpenToCategory(Guide.configpanel); end)
end
