if not HEXIBOOSTER_DONT_LOAD_GUIDE then
  WidgetWarlock = {}

  WidgetWarlock.TooltipBorderBG = {
    bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
    edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
    edgeSize = 16,
    insets = {left = 4, right = 4, top = 4, bottom = 4}
  }


  function WidgetWarlock.SummonCheckBox(size, parent, ...)
    local check = CreateFrame("CheckButton", nil, parent)
    check:SetWidth(size)
    check:SetHeight(size)
    if select(1, ...) then check:SetPoint(...) end

    check:SetNormalTexture("Interface\\Addons\\ManaCore\\Media\\checkbox")
    check:SetPushedTexture("Interface\\Addons\\ManaCore\\Media\\checkbox_pushed")
    check:SetHighlightTexture("Interface\\Addons\\ManaCore\\Media\\checkbox_hover")
    check:SetDisabledTexture("Interface\\Addons\\ManaCore\\Media\\checkbox_disabled")
    check:SetCheckedTexture("Interface\\Addons\\ManaCore\\Media\\checkbox_checked")
    return check
  end


  function WidgetWarlock.SummonTexture(parent, layer, w, h, texture, ...)
    local tex = parent:CreateTexture(nil, layer)
    if w then tex:SetWidth(w) end
    if h then tex:SetHeight(h) end
    tex:SetTexture(texture)
    if select(1, ...) then tex:SetPoint(...) end
    return tex
  end


  function WidgetWarlock.SummonFontString(parent, layer, inherit, text, ...)
    local fs = parent:CreateFontString(nil, layer, inherit)
    fs:SetText(text)
    if select(1, ...) then fs:SetPoint(...) end
    return fs
  end


  -----------------------
  --      Fade In      --
  -----------------------

  local fadetimes = setmetatable({}, {__index = function() return 1 end})
  local elapsed = setmetatable({}, {__index = function() return 0 end})


  function WidgetWarlock.SetFadeTime(frame, time)
    assert(frame, "No frame passed")
    assert(type(time) == "number", "Time must be a number")
    assert(time > 0, "Time must be positive")
    fadetimes[frame] = time
  end


  function WidgetWarlock.FadeIn(frame, elap)
    elapsed[frame] = elapsed[frame] + elap
    if elapsed[frame] > fadetimes[frame] then
      frame:SetScript("OnUpdate", nil)
      frame:SetAlpha(1)
      elapsed[frame] = 0
    else frame:SetAlpha(elapsed[frame]/fadetimes[frame]) end
  end


  --------------------------
  --      Scroll Bar      --
  --------------------------

  function WidgetWarlock.ConjureScrollBar(parent, hasborder)
    local f = CreateFrame("Slider", nil, parent)
    f:SetWidth(16)

    local upbutt = CreateFrame("Button", nil, f)
    upbutt:SetWidth(16)
    upbutt:SetHeight(16)
    upbutt:SetPoint("BOTTOM", f, "TOP")
    upbutt:SetNormalTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_up")
    upbutt:SetHighlightTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_up")
    upbutt:SetDisabledTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_up")
    upbutt:GetNormalTexture():SetVertexColor(0.5,0.5,0.5)
    upbutt:GetHighlightTexture():SetVertexColor(0.5,0.5,0.5)
    upbutt:GetDisabledTexture():SetVertexColor(0.5,0.5,0.5)

    local downbutt = CreateFrame("Button", nil, f)
    downbutt:SetPoint("TOP", f, "BOTTOM")
    downbutt:SetWidth(16)
    downbutt:SetHeight(16)
    downbutt:SetNormalTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_down")
    downbutt:SetHighlightTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_down")
    downbutt:SetDisabledTexture("Interface\\Addons\\ManaCore\\Media\\simple_arrow_down")
    downbutt:GetNormalTexture():SetVertexColor(0.5,0.5,0.5)
    downbutt:GetHighlightTexture():SetVertexColor(0.5,0.5,0.5)
    downbutt:GetDisabledTexture():SetVertexColor(0.5,0.5,0.5)

    f:SetThumbTexture("Interface\\Addons\\ManaCore\\Media\\scroll_middle")
    local thumb = f:GetThumbTexture()
    thumb:SetTexture(1,1,1,0.3)
    thumb:SetBlendMode'ADD'
    thumb:SetHeight(3)
    thumb:SetWidth(16)

    return f, upbutt, downbutt
  end
end
