﻿local _,ns = ...
local m,i = ns:RegisterModule()
m.frames = {}
ns.MuleShopper = m
ns:RegisterModuleEvent(i,'LFG_LOCK_INFO_RECEIVED')
ns:RegisterModuleEvent(i,'PLAYER_EQUIPMENT_CHANGED')

if storedCharacters == nil then
	storedCharacters = {}
end

local currentCharacter = "123"
local currentCharacterName = UnitName('player')..' - '..GetRealmName('player')
local HeadNum = GetInventorySlotInfo("HeadSlot")
local NeckNum = GetInventorySlotInfo("NeckSlot")
local ShoulderNum = GetInventorySlotInfo("ShoulderSlot")
local ShirtNum = GetInventorySlotInfo("ShirtSlot")
local ChestNum = GetInventorySlotInfo("ChestSlot")
local WaistNum = GetInventorySlotInfo("WaistSlot")
local LegsNum = GetInventorySlotInfo("LegsSlot")
local FeetNum = GetInventorySlotInfo("FeetSlot")
local WristNum = GetInventorySlotInfo("WristSlot")
local HandsNum = GetInventorySlotInfo("HandsSlot")
local Finger0Num = GetInventorySlotInfo("Finger0Slot")
local Finger1Num = GetInventorySlotInfo("Finger1Slot")
local Trinket0Num = GetInventorySlotInfo("Trinket0Slot")
local Trinket1Num = GetInventorySlotInfo("Trinket1Slot")
local BackNum = GetInventorySlotInfo("BackSlot")
local MainNum = GetInventorySlotInfo("MainHandSlot")
local SecondaryNum = GetInventorySlotInfo("SecondaryHandSlot")
--local RangedNum = GetInventorySlotInfo("RangedSlot")
local TabardNum = GetInventorySlotInfo("TabardSlot")
local tellCommands-- = true

local equipSlots = {
	[HeadNum] = "HeadSlot",
	[NeckNum] = "NeckSlot",
	[ShoulderNum] = "ShoulderSlot",
	[ShirtNum] = "ShirtSlot",
	[ChestNum] = "ChestSlot",
	[WaistNum] = "WaistSlot",
	[LegsNum] = "LegsSlot",
	[FeetNum] = "FeetSlot",
	[WristNum] = "WristSlot",
	[HandsNum] = "HandsSlot",
	[Finger0Num] = "Finger0Slot",
	[Finger1Num] = "Finger1Slot",
	[Trinket0Num] = "Trinket0Slot",
	[Trinket1Num] = "Trinket1Slot",
	[BackNum] = "BackSlot",
	[MainNum] = "MainHandSlot",
	[SecondaryNum] = "SecondaryHandSlot",
	--[RangedNum] = "RangedSlot",
	[TabardNum] = "TabardSlot",
}

local equipSlots2 = {
	["HeadSlot"] = HeadNum,
	["NeckSlot"] = NeckNum,
	["ShoulderSlot"] = ShoulderNum,
	["ShirtSlot"] = ShirtNum,
	["ChestSlot"] = ChestNum,
	["WaistSlot"] = WaistNum,
	["LegsSlot"] = LegsNum,
	["FeetSlot"] = FeetNum,
	["WristSlot"] = WristNum,
	["HandsSlot"] = HandsNum,
	["Finger0Slot"] = Finger0Num,
	["Finger1Slot"] = Finger1Num,
	["Trinket0Slot"] = Trinket0Num,
	["Trinket1Slot"] = Trinket1Num,
	["BackSlot"] = BackNum,
	["MainHandSlot"] = MainNum,
	["SecondaryHandSlot"] = SecondaryNum,
	--["RangedSlot"] = RangedNum,
	["TabardSlot"] = TabardNum,
}



--function Character:new(o)
--	o = o or {}
--	setmetatable(o, self)
--	self.__index = self
--	return o
--end

function MuleShopperItemSlotButton_OnEnter(self)
	
	GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
	slot = strsub(self:GetName(),12)
	if currentCharacter ~= "123" then
		local slotnum = equipSlots2[slot]
		local storedItems = storedCharacters[currentCharacter]
		local ItemInfo = storedItems[slotnum]		
		if ItemInfo[1] ~= 0 then
			GameTooltip:SetHyperlink(ItemInfo[1])
		end	
	--else
	--	local ItemInfo = GetInventoryItemLink("player", GetInventorySlotInfo(slot))
	--	if ItemInfo ~= nil then
	--		GameTooltip:SetHyperlink(ItemInfo)
	--	end	
	end	
	CursorUpdate(self)
end

function MuleShopperItemSlotButton_OnLoad(self)
	
	if tellCommands then
		print("MuleShopper Addon loaded")
		print("Commands:")
		print("/ms: opens MuleShopper window")
		print("/msclose: closes MuleShopper window")
		print("/msclearall: clears all stored data")
		tellCommands=false
	end
	MuleShopperFrame:Hide()
	local slotName = self:GetName();
	local id
	local textureName
	--local checkRelic
	--id, textureName, checkRelic = GetInventorySlotInfo(strsub(slotName,12))
	--self:SetID(id)
	
	local texture = _G[slotName.."IconTexture"]
	texture:SetTexture(textureName)
	self.backgroundTextureName = textureName
	--self.checkRelic = checkRelic
	
	
end

local function MuleShopper_OnLoad(frame)
	frame:RegisterForDrag("LeftButton")
end

-- initializes drop down menu to select character
function MuleShopperDropDownInitialize()

	local info = UIDropDownMenu_CreateInfo()
	
	info.text="Select Character"
	info.isTitle = true
	UIDropDownMenu_AddButton(info)
	
	for key,value in pairs(storedCharacters) do
		local name = key
		local gold = value.gold
		info = UIDropDownMenu_CreateInfo()
		info.text = name
		info.func = function() 
		    currentCharacter = name
		    MuleShopperUpdateCurrentDisplay()
		end
		
		UIDropDownMenu_AddButton(info)
	end
	
end

function MuleShopperDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, MuleShopperDropDownInitialize)
	UIDropDownMenu_SetText(self, "Select Character")
	UIDropDownMenu_SetWidth(self, 100)
end

function MuleShopperUpdate()	
	--updateCurrentGold()
	MuleShopperUpdateCurrentEquipment()
	--updateCurrentDisplay()
end

function MuleShopperItemSlotButton_Update(frame)
	if frame ~= nil then
		local slotName = frame:GetName()	
		local id
		local textureName
		--local checkRelic
		--id, textureName, checkRelic = GetInventorySlotInfo(strsub(slotName,12))
		--slot = strsub(slotName,12)
		local slotnum = equipSlots2[slot]
		if storedCharacters[currentCharacter] ~= nil then
			local storedItems = storedCharacters[currentCharacter]
			local ItemInfo = storedItems[slotnum]
			if ItemInfo[2] ~= 0 then
		
				local texture = _G[slotName.."IconTexture"]
				texture:SetTexture(ItemInfo[2])
			else
				local texture = _G[slotName.."IconTexture"]
				texture:SetTexture(textureName)
				frame.backgroundTextureName = textureName
				--frame.checkRelic = checkRelic	
			end
		else
			local texture = _G[slotName.."IconTexture"]
			texture:SetTexture(textureName)
			frame.backgroundTextureName = textureName
		--	frame.checkRelic = checkRelic
		end	
	end
end	

function MuleShopperUpdateCurrentDisplay()
	
	
--	for id,slot in pairs(equipSlots) do
--		SetItemButtonTexture(button, textureName)
--	end
	MuleShopperItemSlotButton_Update(MuleShopperHeadSlot)
	MuleShopperItemSlotButton_Update(MuleShopperNeckSlot)
  MuleShopperItemSlotButton_Update(MuleShopperShoulderSlot)
	MuleShopperItemSlotButton_Update(MuleShopperBackSlot)
	MuleShopperItemSlotButton_Update(MuleShopperChestSlot)
	MuleShopperItemSlotButton_Update(MuleShopperShirtSlot)
	MuleShopperItemSlotButton_Update(MuleShopperTabardSlot)
	MuleShopperItemSlotButton_Update(MuleShopperWristSlot)
	
    MuleShopperItemSlotButton_Update(MuleShopperHandsSlot)
    MuleShopperItemSlotButton_Update(MuleShopperWaistSlot)
    MuleShopperItemSlotButton_Update(MuleShopperLegsSlot)
    MuleShopperItemSlotButton_Update(MuleShopperFeetSlot)
    MuleShopperItemSlotButton_Update(MuleShopperFinger0Slot)
    MuleShopperItemSlotButton_Update(MuleShopperFinger1Slot)
    MuleShopperItemSlotButton_Update(MuleShopperTrinket0Slot)
    MuleShopperItemSlotButton_Update(MuleShopperTrinket1Slot)
			
    MuleShopperItemSlotButton_Update(MuleShopperMainHandSlot)
    MuleShopperItemSlotButton_Update(MuleShopperSecondaryHandSlot)
    --MuleShopperItemSlotButton_Update(MuleShopperRangedSlot)
	if storedCharacters[currentCharacter] ~= nil then
		local StoredInfo = storedCharacters[currentCharacter]
		gold = StoredInfo["GoldAmount"]
		MuleShopperFrame.char:SetText(currentCharacter)
	else
		gold = 0
		MuleShopperFrame.char:SetText("Select Character")
	end	
	MuleShopperFrame.gold:SetText(GetCoinText(gold))
	
end

function MuleShopperUpdateCurrentEquipment()
	-- store item links and textures
	local ItemTables = {}
	for i=1,19 do
		slot = equipSlots[i]
		ItemLink = GetInventoryItemLink("player",i)
		ItemTexture = GetInventoryItemTexture("player",i)		
		if ItemLink ~= nil then
			table.insert(ItemTables, {ItemLink,ItemTexture})
		else
			table.insert(ItemTables, {0,0})
		end		
	end
	local GoldAmount = GetMoney()
	ItemTables["GoldAmount"] = GoldAmount
	
	storedCharacters[currentCharacterName] = ItemTables
	
--	for num,slot in ipairs(equipSlotNames) do
--		current[slot] = {}
--		current[slot].link = GetInventoryItemLink("player",slot)
--		current[slot].tex = GetInventoryItemTexture("player",num)
--	end
end

-- updates current character's gold
local function updateCurrentGold()
	
	local StoredInfo = storedCharacters[currentCharacter]
	
	if storedCharacters[currentCharacter] == nil then
	    --print("ERROR UPDATE_CURRENT_GOLD: character not in database")
	else
		storedCharacters[currentCharacter].gold = GetMoney()
	end

end

function MuleShopperClear_ButtonOnClick()
	print("Stored Characters have been Cleared")
	storedCharacters = {}
	currentCharacter = "123"
	MuleShopperUpdateCurrentDisplay()
end

-- SLASH COMMANDS

SLASH_MULESHOPPER1, SLASH_MULESHOPPER2 = '/ms', '/muleshopper'
SlashCmdList["MULESHOPPER"] = function()
	ns.db.show_muleshop = not ns.db.show_muleshop;
end

--local function muleshopper_handler(msg, editbox)
--	MuleShopperFrame:Show()
--end

 --SLASH_MULESHOPPERCLOSE1, SLASH_MULESHOPPERCLOSE2 = '/msclose', '/muleshopperclose';
--local function muleshopper_close(msg, editbox)
--	MuleShopperFrame:Hide()
--end
--SlashCmdList["MULESHOPPERCLOSE"] = muleshopper_close

SLASH_CLEARALL1 = '/msclearall'
local function clearall_handler(msg, editbox)
	print("Stored Characters have been Cleared")
	storedCharacters = {}
	currentCharacter = "123"
	MuleShopperUpdateCurrentDisplay()
end
SlashCmdList["CLEARALL"] = clearall_handler

local initialized
m.MANACORE_VARS_CHANGED = function (self,var,old,new)
	if var == 'show_muleshop' then
		if new and not(MuleShopperFrame:IsShown()) then
			MuleShopperFrame:Show()
		elseif MuleShopperFrame:IsShown() then
			MuleShopperFrame:Hide()
		end
		if MuleShopperFrame_Close and not(initialized) then
			MuleShopperFrame_Close:SetScript("OnClick", function()
				ns.vars.show_muleshop = false
			end)
			initialized = true
		end
	end
end

-- Use a 2-second rolling update period for equipment updates, prevents updating 10+ times at once when switching gear sets.
-- Also helps a bit with cache issues.
local rolling
local TSS = 0
local frame = CreateFrame('Frame',nil,WorldFrame)
local delayedUpdate = function (self,elapsed)
	TSS = TSS+elapsed
	if TSS > 2 then
		rolling = nil
		self:SetScript('OnUpdate',nil)
		MuleShopperUpdateCurrentEquipment()
		--print('update finished')
	end
end

local StartDelayedUpdate = function ()
	if not(rolling) then
		rolling = true
		TSS = 0
		frame:SetScript('OnUpdate',delayedUpdate)
		--print('beginning delayed update')
	end
end

m.PLAYER_EQUIPMENT_CHANGED = function (self,slot,equipped)
	StartDelayedUpdate()
end

m.LFG_LOCK_INFO_RECEIVED = function (self)
	StartDelayedUpdate()
end
