﻿--Auctionator.lua
--This file provides a scanner interface for use with Tycoon
--when the Auctionator addon is present.
--TODO: rest of documentation
--NOTE: A large portion of this file is not currently in use. It was developed
--	by Ezra but left incomplete and untested and then taken over by John. I have
--  not pruned things because they may be useful in the future.
if IsAddOnLoaded("Auctionator") then
	local _,ns = ...
	local m,i,dbStatus = ns:RegisterModule(nil,"Auctionator",'AUCTION_HOUSE_SHOW')
	local faction, adb
	
	local today = Atr_GetScanDay_Today()
	local dayzero = gScanHistDayZero
	-- gAtr_ScanDB -- Scan DB for the current server/faction, available at AUCTIONATOR_DB_READY -- gAtr_ScanDB[itemName] = { [type..dateString] = priceInCopper }
	
	local d = 'HI'..today
	local dl = 'LI'..today
	local o = 'HO'..today
	local ol = 'LO'..today
	local co = 'CO'..today
	local own = '+'..today
	
	local round = function (v)
		math.floor (v + 0.5)
	end
	
	-- FromShortDate: Returns numeric shortdate, datestring, and date()-format for a given shortdate in string or number format
	local FromShortDate = function (t)
		local day = (type(t) == 'string' and tonumber(string.sub(t,2))) or t
		local when = dayzero + (day*86400)
		local datestring
		if day == today then
			datestring = 'Today'
		elseif day == today-1 then
			datestring = 'Yesterday'
		else
			datestring = date("%A, %B %d", when)
		end
		return day, datestring, when
	end
	
	-- ToShortDate: Returns numeric shortdate from time()
	local ToShortDate = function (t)
		return (math.floor ((t - gScanHistDayZero) / (86400)))
	end
	
	--UpdateDay: Forces all day related variables to update after a scan
	--KNOWN BUG: If a scan starts before, but ends after, a day change this
	--	will be incorrect. Low occurance race condition. Won't Fix.
	local UpdateDay = function ()
		today = Atr_GetScanDay_Today()
		
		d = 'HI'..today
		dl = 'LI'..today
		o = 'HO'..today
		ol = 'LO'..today
		co = 'CO'..today
		own = '+'..today
	end
	
	m.TYCOON_VARIABLES_CHANGED = function (self,k,old,new)
	
	end
	
	m.TYCOON_VARIABLES_READY = function (self)
		ns.vars.today = today
	end
	
	--NOTE: NOTHING SHOULD BE DONE WITH ADB AT CFG_READY_GLOBAL
	--API module is not garunteed to be done with it's setup yet
	m.TYCOON_CFG_READY_GLOBAL = function (self)
	end
	
	m.TYCOON_CFG_CHANGED_GLOBAL = function (self,k,old,new)
	end
	
	--Cleans both factions due to bug in initial db version
	m.CleanDb = function ()
		local adb
		local md = AUCTIONATOR_DB_MAXHIST_DAYS
		
		adb = ns.adb.auctionator["Alliance"]
		m:mdebug('cleaning up Alliance db entries')
		local removed = 0
		if adb then
			for item,data in pairs(adb) do -- clean up the db according to Auctionator's prefs
				for day, values in pairs(data) do
					local d = tonumber(day) -- just in case.
					if d and (d < (today-md)) then
						removed = removed + 1
						data[day] = nil;
					end
				end
			end
		end
		m:mdebug(removed..' entries removed')
		
		adb = ns.adb.auctionator["Horde"]
		m:mdebug('cleaning up Horde db entries')
		local removed = 0
		if adb then
			for item,data in pairs(adb) do -- clean up the db according to Auctionator's prefs
				for day, values in pairs(data) do
					local d = tonumber(day) -- just in case.
					if d and (d < (today-md)) then
						removed = removed + 1
						data[day] = nil;
					end
				end
			end
		end
		m:mdebug(removed..' entries removed')
	end
	
	m.PLAYER_ENTERING_WORLD = function (self)
		faction = UnitFactionGroup("player")
		ns.adb.auctionator = ns.adb.auctionator or {}
		ns.adb.auctionator[faction] = ns.adb.auctionator[faction] or {}
		adb = ns.adb.auctionator[faction]
		
		m.CleanDb()
		
		ns:FireEvent('AUCTIONATOR_DB_READY')
		--We only need to do this once, but what we want to do 
		--may not be ready at PLAYER_LOGIN
		m:UnregisterEvent("PLAYER_ENTERING_WORLD")
	end
	m:RegisterEvent("PLAYER_ENTERING_WORLD")
	
	local sessionScan,sessionScanStarted
	m.AUCTION_HOUSE_SHOW = function (self)
		if not IsAddOnLoaded("Auc-Advanced") and ns.db.autoscan == true and ns.db.lastscanday ~= today then
			local canQuery,canQueryAll = CanSendAuctionQuery()
			if canQueryAll then
				sessionScanStarted = true
				Atr_ShowFullScanFrame()
				Atr_FullScanStart()
			end
		end
	end
	
	local temp = {}
	m.PostScan = function (self)
		--This function originally tried to count number of sellers
		--This functionality fails due to owner often being nil due to name cache resolving
		--Some of the code remains in case we ever want to include the data if available
		local numBatchAuctions, totalAuctions = GetNumAuctionItems("list")
		m:mdebug('postscan init using '..numBatchAuctions..'/'..totalAuctions..' auctions')
		local name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus
	
		table.wipe(temp)
		
		local start = GetTime()
		for i = 1,numBatchAuctions do -- batch process for later insertion
			name, texture, count, quality, canUse, level, minBid, minIncrement, buyoutPrice, bidAmount, highBidder, owner, saleStatus = GetAuctionItemInfo("list", i)
			if name then
				temp[name] = temp[name] or {}
				--temp[name].pnames = temp[name].pnames or {}
				--temp[name].onames = temp[name].onames or {}
				
				temp[name].posts = temp[name].posts and (temp[name].posts + 1) or 1
				--[[--owner code
				if owner and temp[name].onames[owner] ~= true then
					temp[name].owners = temp[name].owners and (temp[name].owners + 1) or 1
					temp[name].onames[owner] = true
				end
				--]]
				
				m:mdebug(name, temp[name].posts)
			end
		end
		
		m:mdebug('postscan today is ' .. today)
		
		for item,data in pairs(temp) do -- insert data into the db
			adb[item] = adb[item] or {}
			adb[item][today] = adb[item][today] or {}
			local i = adb[item][today]
			
			i.posts = i.posts or {}
			--i.owners = i.owners or {}
	
			-- Should only create entries if needed.
			i.posts.current = data.posts
			i.posts.min = (i.posts.min and data.posts < i.posts.min and data.posts) or i.posts.min or data.posts
			i.posts.max = (i.posts.max and data.posts > i.posts.max and data.posts) or i.posts.max or data.posts
		end		
	end
	
	--Auctionator scan callbacks
	local updateTypes = {
		['partialscan'] = function (num,binfo) -- Fired on partial listing updates (AtrSearch, buy/post lookups); No owner lookups here, since we don't have complete data, just letting the API know that the Auctionator db has been updated.
			UpdateDay()
			ns:FireEvent('AUCTIONATOR_SCAN_PARTIAL',binfo)
		end,
		
		['fullscan'] = function (num) -- Fired when a full scan has been completed, fire AUCTIONATOR_FULL_SCAN api event
			--this should fire before auctionator auto-clears the auction window
			--if it does not, hook Atr_ClearBrowseListings to a blank function
			UpdateDay()
			m:PostScan()
		
			--Note: Scanday code is only used here so far, is it needed?
			local ins = true
			for i,day in ipairs(ns.dbs.scandays) do
				if day == today then
					ins = nil
				end
			end
			if ins then table.insert(ns.dbs.scandays,today) end
			table.sort(ns.dbs.scandays) -- make sure the first date is always first for trimming
			while #ns.dbs.scandays > AUCTIONATOR_DB_MAXHIST_DAYS do
				table.remove(ns.dbs.scandays, 1)
			end
			table.sort(ns.dbs.scandays) -- just in case.
			
			ns:FireEvent('AUCTIONATOR_SCAN_FULL')
			
			if sessionScanStarted then Atr_FullScanFrame:Hide() end
			ns.db.lastscanday = today
		end,
		
		['dbinited'] = function (num) -- Fired when Auctionator savedvariables are initialized
			AUCTIONATOR_DB_MAXHIST_DAYS = AUCTIONATOR_DB_MAXHIST_DAYS > 13 and AUCTIONATOR_DB_MAXHIST_DAYS or 14 -- make sure we're always getting at least two weeks of history
			--ns:FireEvent('AUCTIONATOR_DB_READY') --now fires when the local DB is ready as well
		end,
	}
	
	m.OnAuctionatorDBUpdate = function (num,kind,binfo)
		if (num and kind and updateTypes[kind]) then return updateTypes[kind](num,binfo) end
	end
	Atr_RegisterFor_DBupdated(m.OnAuctionatorDBUpdate)
	
	-- ReloadUI safety calls, should also handle early VARIABLES_READY firing
	if ns.vars and ns.vars._INITIALIZED then m:TYCOON_VARIABLES_READY() end
	if ns.vars and ns.vars._INITIALIZED then m:TYCOON_CFG_READY_GLOBAL() end
	
	
	local average = function (t)
		if #t == 0 then return end
		local x = 0
		for i = 1,#t do
			x = x+t[i]
		end
		return #t>0 and (x/#t) or 0
	end
	
	local stddev = function (t)
		if #t == 0 then return end
		local avg = average(t)
		local temp = {}
		for i = 1,#t do
			temp[i] = (t[i]-avg)^2
		end
		local dev = math.sqrt(average(temp))
		local high = avg + (dev * 2) + 10
		local low = avg - (dev * 2) - 10
		return dev, avg, high, low
	end
	
	--[[
		Do-wrapped function declarations so we're dealing with locals everywhere
	]]--
	
	local outliers
	do
		local temp = {}
		outliers = function (t)
			if #t == 0 then return end
			local dev,avg,high,low = stddev(t)
			table.wipe(temp)
	
			local outlierfound
			for i = 1,#t do
				local outlier = (t[i] > high) or (t[i] < low)
				outlierfound = outlierfound or outlier
				if not(outlier) then table.insert(temp,t[i]) end
			end
	
			if outlierfound then
				t,dev,avg,high,low = outliers(temp)
				return temp,dev,avg,high,low
			end
			return temp,dev,avg,high,low
		end
	end
	
	-- Return a table with no non-number values
	local safetable = function (...)
		local it = type(select(1,...)) == 'table' and select(1,...)
		local t = {}
		if it then
			for k,v in pairs(it) do
				if tonumber(v) then table.insert(t,tonumber(v)) end
			end
		else
			for i = 1,select('#',...) do
				local v = select(i,...)
				if tonumber(v) then table.insert(t,tonumber(v)) end
			end
		end
		return t
	end
	
	-- These funcs will break if handed itemID, use namespaced funcs instead.
	local GetPriceByDay, GetListingsByDay, GetLastListings, GetTrend, GetCompetition, GetItemTradeIndex, PopulateItemInfo
	do
		local temp = {}
		
		GetPriceByDay = function (item,day)
			if (not gAtr_ScanDB) or (not gAtr_ScanDB[item]) then return end
			local day = day or today
			
			local current = gAtr_ScanDB[item].mr
			local highlow = gAtr_ScanDB[item]['H'..day]
			local lowlow = gAtr_ScanDB[item]['L'..day]
			return current,highlow,lowlow
		end
	
		GetListingsByDay = function (item,day)
			local day = day or today
			if not(adb[item] and adb[item][day]) then return end
			local i = adb[item][day]
			return i.posts.current, i.posts.min, i.posts.max--[[, i.owners.current, i.owners.min, i.owners.max]]
		end
		
		GetLastListings = function (item)
			if not adb[item] then return end
			local lday = 0
			local i
			for day, data in pairs(adb[item]) do
				if day > lday then
					lday, i = day, data
				end
			end
			if i then return i.posts.current, i.posts.min, i.posts.max end
		end
		
		GetAverage = function(item, period)
			if (not gAtr_ScanDB) or (not gAtr_ScanDB[item]) then return end
			table.wipe(temp)
			local period = period or 14
			local attempt = 0
			while period >= 0 do
				local c,h,l = GetPriceByDay(item,today-period)
				--table.insert(temp,c) -- wtb table.insert(unpack)
				--table.insert(temp,h)
				if l or h then table.insert(temp,l or h) end;
				period = period-1
			end
			local t,dev,avg = outliers(safetable(temp))
			--avg = (avg + c) / 2
			return avg or 0;
		end
	
		--This needs another look
		--currently returns the percentage difference between current and average
		GetTrend = function (item,period) -- Get trend over the past [period] scan days (default 14)
			if (not gAtr_ScanDB) or (not gAtr_ScanDB[item]) then return end
			local avg = GetAverage(item, period)
			local c = gAtr_ScanDB[item].mr
			--avg = (avg + c) / 2
			return avg and (c-avg)/avg or 0
		end
	
		GetCompetition = function (item,day,byDay)
			local day = tonumber(day) or today
			if not(adb[item] and adb[item][day]) then return end
			local cp,mp,xp,co,mo,xo = GetListingsByDay(item,day)
			local ap = byDay and average(safetable(cp,mp,xp)) or cp
			local ao = byDay and average(safetable(co,mo,xo)) or co
			return (ap * (ao/ap)^2)
		end
	
		GetItemTradeIndex = function (t)
			return (t.price/10000)*(1/t.competition)*(1+t.trend)
		end
	end
	m.IsDBReady = function()
		if gAtr_ScanDB and adb then
			return true
		end
		return false
	end
	m.GetItemPrice = function (item,daysago)
		item = type(item) == 'string' and item or GetItemInfo(item)
		if not(item) or type(item)=='number' then return end
		daysago = daysago and today - daysago
		local c, h, l = GetPriceByDay(item,daysago)
		if daysago then return l or h, h, l else return c, h, l end --c is always current day, replace for daysago
	end
	m.GetAveragePrice = function(item)
		item = type(item) == 'string' and item or GetItemInfo(item)
		if not(item) or type(item)=='number' then return end
		return GetAverage(item, period)
	end
	m.GetCurrentListings = function (item)
		item = type(item) == 'string' and item or GetItemInfo(item)
		if not item or type(item)=='number' then return end
		return GetListingsByDay(item)
	end
	m.GetItemListings = function (item)
		item = type(item) == 'string' and item or GetItemInfo(item)
		if not(item) or type(item)=='number' then return end
		return GetLastListings(item)
	end
	--Currently returns a percentage compared to average
	m.GetItemTrend = function (item,period)
		item = type(item) == 'string' and item or GetItemInfo(item)
		if not(item) or type(item)=='number' then return end
		return GetTrend(item,period)
	end
end--End IsAddonLoaded("Auctionator")
