local _,ns = ...
local m,i = ns:RegisterModule(nil,'GUI')
local mainframe = CreateFrame('Frame','TycoonSelectionFrame',UIParent)
local charframe = CreateFrame('Frame','TycoonSelectionFrame_Char',mainframe)
local suggestframe = CreateFrame('Frame','TycoonSelectionFrame_Suggest',mainframe)
charframe:Hide()
suggestframe:Hide()

-- Try our hardest to pull a valid class icon. Takes a frame and name or class as args.
local SetClassIcon = function (f,n)
	f:SetTexture('Interface\\TargetingFrame\\UI-Classes-Circle')
	f:SetTexCoord(unpack(CLASS_ICON_TCOORDS[n and (CLASS_ICON_TCOORDS[n] or (ns.dbs[n] and ns.dbs[n].class)) or select(2,UnitClass('player'))]))
end

local cache = {
	char = {},
	suggest = {},
}

local create = {
	char = function (self)
		local f = table.insert(self.objects,CreateFrame('Frame',nil,self))
		
	end,

	suggest = function (self)

	end,
}

local get = function (self,t)
	if #cache[t] > 0 then return table.remove(cache[t][1]) end
	return create[t](self)
end

local keep = { [0] = true, objects = true }
local toss = function (f,t)
	for k,v in pairs(f) do
		if not(keep[k]) then f[k]=nil end
	end
	f:Hide()
	table.insert(cache[t],f)
end

local selectStates = {
	['char'] = function ()

	end

	['item'] = function ()

	end

	['suggest'] = function ()

	end
}

m.TYCOON_VARIABLES_CHANGED = function (self,k,old,new)
	if k == 'selectState' then return selectStates[ns.vars.selectState]() end
end

m.TYCOON_VARIABLES_READY = function (self)
	ns.vars.selectState = 'type'
end

-- ReloadUI safety calls, should also handle early VARIABLES_READY firing
if m.DBEvents.TYCOON_VARIABLES_READY and m.DBEvents.TYCOON_VARIABLES_READY._INITIALIZED then m:TYCOON_VARIABLES_READY() end
if m.DBEvents.TYCOON_CFG_READY_GLOBAL and m.DBEvents.TYCOON_CFG_READY_GLOBAL._INITIALIZED then m:TYCOON_CFG_READY_GLOBAL() end
