﻿local AddonName,ns = ...
local m,i = ns:RegisterModule(nil,"PanelAPI")

TYCOON_PANEL_CONTENT_HEIGHT = 294;
TYCOON_PANEL_CONTENT_HEIGHT_OFFSET = -65;
TYCOON_PANEL_CONTENT_WIDTH = 833;
TYCOON_PANEL_CONTENT_WIDTH_OFFSET = 11;
TYCOON_PANEL_CONTENT_TITLE_HEIGHT = 30;

local f = CreateFrame("Frame", "TycoonPanel", UIParent, nil);
f:SetFrameStrata("HIGH")
f:SetSize(855, 416);
f:SetPoint("CENTER", UIParent, "CENTER");
f:EnableMouse(true);
f:Hide()
m.panel = f;

--Turns frame into a standard UI panel
f:SetAttribute("UIPanelLayout-defined", true)
f:SetAttribute("UIPanelLayout-enabled", true)
f:SetAttribute("UIPanelLayout-area", "doublewide")
f:SetAttribute("UIPanelLayout-pushable", 5)
f:SetAttribute("UIPanelLayout-width", 855)
f:SetAttribute("UIPanelLayout-whileDead", true)
--ShowUIPanel(f)

f.background = f:CreateTexture(nil, "BACKGROUND", nil);
f.background:SetSize(855,416);
f.background:SetPoint("CENTER");
f.background:SetTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Background');
f.background:SetTexCoord(0, 0.8349609375, 0, 0.40625);
f.background:Show();

f.close = CreateFrame("Button", nil, f, nil);
f.close:SetSize(25, 25);
f.close:SetPoint("TOPRIGHT", f, "TOPRIGHT", -7, -7);
f.close:SetNormalTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Close');
f.close:GetNormalTexture():SetTexCoord(0, 0.75, 0, 0.75);
f.close:SetHighlightTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Close');
f.close:GetHighlightTexture():SetTexCoord(0, 0.75, 0, 0.75);
f.close:SetPushedTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Close');
f.close:GetPushedTexture():SetTexCoord(-0.05, 0.80, 0, 0.80);
f.close:SetScript("OnClick", function() HideUIPanel(f) end);
f.close:Show();

f.tabs = {}
local activeTab;

--[[ NOTE: Kind of pointless with one script, maintaining for later use
local tabScripts = {
	OnClick = function(tab) 
		if(activeTab) then
			f.tabs[activeTab].activeBG:Hide();
			f.tabs[activeTab]:SetNormalFontObject("GameFontHighlight");
		end
		tab.activeBG:Show();
		tab:SetNormalFontObject("GameFontNormal");
		activeTab = tab:GetID();
	end,
}
--]]

function m.AddPanelTab(label)
	local id = #f.tabs + 1;
	
	local tab = CreateFrame("Button", nil, f, nil, id);
	tab:SetSize(132, 49);
	if (id == 1) then
		tab:SetPoint("TOPLEFT", f, "TOPLEFT", 42, -10)
	else
		tab:SetPoint("LEFT", f.tabs[id-1].tab, "RIGHT", -3, 0)
	end
	
	local t = tab:CreateTexture(nil, "BACKGROUND", nil)
	t:SetAllPoints(true)
	t:SetTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Tabs')
	t:SetTexCoord(0, 0.515625, 0, 0.19140625)
	t:Hide()
	tab.activeBG = t
	
	tab:SetNormalTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Tabs')
	tab:SetHighlightTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_Tabs')
	tab:GetNormalTexture():SetTexCoord(0, 0.515625, 0.1953125, 0.3828125)
	tab:GetHighlightTexture():SetTexCoord(0, 0.515625, 0.1953125, 0.3828125)
	tab:Show()
	
	tab:SetNormalFontObject("GameFontHighlight");
	tab:SetHighlightFontObject("GameFontNormal");
	tab:SetText(label)
	
	--[[ NOTE: Kind of pointless with one script, maintaining for later use
	for k, v in pairs(tabScripts) do
		tab:SetScript(k, v);
	end
	--]]
	tab:SetScript("OnClick", function(tab) 
		if(activeTab) then
			f.tabs[activeTab].tab.activeBG:Hide()
			f.tabs[activeTab].tab:SetNormalFontObject("GameFontHighlight")
			f.tabs[activeTab].container:Hide()
		end
		tab.activeBG:Show()
		tab:SetNormalFontObject("GameFontNormal")
		activeTab = tab:GetID()
		f.tabs[activeTab].container:Show()
	end)
	
	local container = CreateFrame("Button", nil, f, nil, id)
	container:SetSize(TYCOON_PANEL_CONTENT_WIDTH, TYCOON_PANEL_CONTENT_HEIGHT);
	container:SetPoint("TOPLEFT", f, "TOPLEFT", 
		TYCOON_PANEL_CONTENT_WIDTH_OFFSET, TYCOON_PANEL_CONTENT_HEIGHT_OFFSET)
	container:Hide()
	
	tinsert(f.tabs, {tab = tab, container = container})
	
	if id == 1 then --make the first registered tab active by default
		tab.activeBG:Show()
		tab:SetNormalFontObject("GameFontNormal")
		activeTab = tab:GetID()
		f.tabs[activeTab].container:Show()
	end
	
	return id, container;
end
--for i = 1, 6 do
--	AddTab("Tab "..i)
--end

--Signal Bars Widget
--TODO: documentation
function m.CreateSignalBars(name, parent, id)
	local f = CreateFrame("Frame", name, parent, nil, id);
	f:SetSize(47, 24)
	
	local previous = f;
	f.bars = {}
	--Create the bars
	for i = 1, 5 do
		f.bars[i] = f:CreateTexture(nil, "ARTWORK");
		f.bars[i]:SetTexture('Interface\\AddOns\\Tycoon\\Media\\Tycoon_Panel_SignalBars');
		f.bars[i]:SetTexCoord(0, 0.194444, 0, 0.666666);
		f.bars[i]:SetSize(7, 12+((i-1)*3));
		f.bars[i]:SetPoint("BOTTOMLEFT", previous, i==1 and "BOTTOMLEFT" or "BOTTOMRIGHT", i==1 and 0 or 3, 0);
		
		previous = f.bars[i];
	end
	
	f.strength = 0;
		
	f.SetStrength = function(frame, strength)
		frame.strength = strength
		for i = 1, 5 do
			if i <= strength then
				f.bars[i]:SetTexCoord(0.194444, .388888, 0, 0.666666);
			else
				f.bars[i]:SetTexCoord(0, 0.194444, 0, 0.666666);
			end
		end
	end
	
	f.GetStrength = function(frame)
		return frame.strength
	end
	
	return f;
end
