﻿local AddonName, ns = ...
local m = ns:RegisterModule(nil, "ShoppingList")

local shoplist = {}
TYCOON_SHOPLIST = shoplist
local listname = ""

---frame creation---
local frame = CreateFrame("Frame", nil, UIParent)
frame:SetWidth(240)
frame:SetHeight(305)
frame:SetPoint("Center", UIParent, "Center")
frame:EnableMouse()
frame:SetMovable(true)
frame:SetFrameStrata("DIALOG")
frame:Hide()
	
local titlebg = frame:CreateTexture(nil, "BACKGROUND")
titlebg:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Title-Background]])
titlebg:SetPoint("TOPLEFT", 9, -6)
titlebg:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -28, -24)

local dialogbg = frame:CreateTexture(nil, "BACKGROUND")
dialogbg:SetTexture([[Interface\Tooltips\UI-Tooltip-Background]])
dialogbg:SetPoint("TOPLEFT", 8, -24)
dialogbg:SetPoint("BOTTOMRIGHT", -6, 8)
dialogbg:SetVertexColor(0, 0, 0, .95)

local topleft = frame:CreateTexture(nil, "BORDER")
topleft:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
topleft:SetWidth(64)
topleft:SetHeight(64)
topleft:SetPoint("TOPLEFT")
topleft:SetTexCoord(0.501953125, 0.625, 0, 1)

local topright = frame:CreateTexture(nil, "BORDER")
topright:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
topright:SetWidth(64)
topright:SetHeight(64)
topright:SetPoint("TOPRIGHT")
topright:SetTexCoord(0.625, 0.75, 0, 1)

local top = frame:CreateTexture(nil, "BORDER")
top:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
top:SetHeight(64)
top:SetPoint("TOPLEFT", topleft, "TOPRIGHT")
top:SetPoint("TOPRIGHT", topright, "TOPLEFT")
top:SetTexCoord(0.25, 0.369140625, 0, 1)

local bottomleft = frame:CreateTexture(nil, "BORDER")
bottomleft:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
bottomleft:SetWidth(64)
bottomleft:SetHeight(64)
bottomleft:SetPoint("BOTTOMLEFT")
bottomleft:SetTexCoord(0.751953125, 0.875, 0, 1)

local bottomright = frame:CreateTexture(nil, "BORDER")
bottomright:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
bottomright:SetWidth(64)
bottomright:SetHeight(64)
bottomright:SetPoint("BOTTOMRIGHT")
bottomright:SetTexCoord(0.875, 1, 0, 1)

local bottom = frame:CreateTexture(nil, "BORDER")
bottom:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
bottom:SetHeight(64)
bottom:SetPoint("BOTTOMLEFT", bottomleft, "BOTTOMRIGHT")
bottom:SetPoint("BOTTOMRIGHT", bottomright, "BOTTOMLEFT")
bottom:SetTexCoord(0.376953125, 0.498046875, 0, 1)

local left = frame:CreateTexture(nil, "BORDER")
left:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
left:SetWidth(64)
left:SetPoint("TOPLEFT", topleft, "BOTTOMLEFT")
left:SetPoint("BOTTOMLEFT", bottomleft, "TOPLEFT")
left:SetTexCoord(0.001953125, 0.125, 0, 1)

local right = frame:CreateTexture(nil, "BORDER")
right:SetTexture([[Interface\PaperDollInfoFrame\UI-GearManager-Border]])
right:SetWidth(64)
right:SetPoint("TOPRIGHT", topright, "BOTTOMRIGHT")
right:SetPoint("BOTTOMRIGHT", bottomright, "TOPRIGHT")
right:SetTexCoord(0.1171875, 0.2421875, 0, 1)

local close = CreateFrame("Button", nil, frame, "UIPanelCloseButton")
close:SetPoint("TOPRIGHT", 2, 1)

local titletext = frame:CreateFontString(nil, "ARTWORK")
titletext:SetFontObject(GameFontNormal)
titletext:SetPoint("TOPLEFT", 12, -8)
titletext:SetPoint("TOPRIGHT", -32, -8)
titletext:SetText("Tycoon Shopping List")

local title = CreateFrame("Button", nil, frame)
title:SetPoint("TOPLEFT", titlebg)
title:SetPoint("BOTTOMRIGHT", titlebg)
title:EnableMouse()
title:SetScript("OnMouseDown", function(self) self:GetParent():StartMoving() end)
title:SetScript("OnMouseUp", function(self) 
	self:GetParent():StopMovingOrSizing()
	ns.dbpc.sl_point, _, ns.dbpc.sl_relpoint, ns.dbpc.sl_x, ns.dbpc.sl_y = frame:GetPoint()
end)

--content container that excludes frame borders for easy anchoring
local content = CreateFrame("Frame", nil, frame)
content:SetWidth(frame:GetWidth() - 16)
content:SetPoint("TOP", frame, "TOP", 1, -25)
content:SetPoint("BOTTOM", frame, "BOTTOM", 1, 8)
	
local listnametext = content:CreateFontString(nil, "ARTWORK")
listnametext:SetFontObject(GameFontWhite)
listnametext:SetWidth(content:GetWidth())
listnametext:SetPoint("TOP", 0, -1)
listnametext:SetText("Tycoon Module List")

local scrollframe = CreateFrame("ScrollFrame", "TSL_ScrollFrame", content, "FauxScrollFrameTemplateLight")
scrollframe:SetPoint("TOPLEFT", listnametext, "BOTTOMLEFT", 4, -4) --4 right for child border, 4 down for slider
scrollframe:SetHeight(200)
scrollframe:SetWidth(content:GetWidth()-32)

local scrollchild = scrollframe:GetScrollChild()

local scrollchildborder = CreateFrame("Frame", nil, scrollframe)
scrollchildborder:SetBackdrop({
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border", tile = true,
			edgeSize = 12, tileSize = 16, insets = {left = 0, right = 0, top = 0, bottom = 0},
			})
scrollchildborder:SetPoint("TOPLEFT", scrollframe, "TOPLEFT", -4, 4) --left 4 to prevent border overlap, up 4 to line up with slider
scrollchildborder:SetHeight(scrollframe:GetHeight()+8) --8 more to line up with slider border
scrollchildborder:SetWidth(scrollframe:GetWidth()+4) --4 extra for left border offset

local slider = _G[scrollframe:GetName() .. "ScrollBar"]

local clearbtn = CreateFrame("Button", nil, frame, "UIPanelButtonTemplate")
clearbtn:SetSize(65, 22)
clearbtn:SetPoint("TOPRIGHT", scrollframe, "BOTTOMRIGHT", 0, -4)
clearbtn:SetText("Clear")

local removebtn = CreateFrame("Button", nil, frame, "UIPanelButtonTemplate")
removebtn:SetSize(65, 22)
removebtn:SetPoint("RIGHT", clearbtn, "LEFT")
removebtn:SetText("Remove")

local helptext = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
helptext:SetPoint("BOTTOMLEFT", 8, 8)
helptext:SetWidth(frame:GetWidth()-16)
helptext:SetText("Shift-click any item in the list to link that item or enter it into an open auction search.")

---frame methods---
local listobjs = {}
local selected;

local function UpdateSelection(index)
	if(selected ~= nil) then
		listobjs[selected]:UnlockHighlight()
	end
	selected = index
	if(selected ~= nil) then
		listobjs[selected]:LockHighlight()
	end			
end


local function SelectionButton_OnClick(self)
	if IsShiftKeyDown() then
		--TODO: Generate item link
		HandleModifiedItemClick(select(2,GetItemInfo(shoplist[self:GetID()].item)))
	else
		UpdateSelection(self:GetID())
	end
end

local function CreateSelectionButton(index)
	local btn = CreateFrame("Button", nil, scrollchild)
	local btnwidth = scrollframe:GetWidth()-8 --for borders
	
	btn:SetHeight(12) --font is 10, 2 for padding
	btn:SetWidth(btnwidth)
	btn:SetHighlightTexture("Interface\\QuestFrame\\UI-QuestTitleHighlight", "ADD")
	if index == 1 then
		btn:SetPoint("TOPLEFT", scrollchild, "TOPLEFT")
	else
		btn:SetPoint("TOP", listobjs[index-1], "BOTTOM")
	end
	
	btn:SetID(index)
	btn:SetScript("OnClick", SelectionButton_OnClick)
	
	listobjs[index] = btn;
	
	btn.item = btn:CreateFontString(nil, "OVERLAY", "GameFontWhiteSmall")
	btn.item:SetJustifyH("LEFT")
	btn.item:SetPoint("LEFT")
	btn.item:SetWidth(btnwidth * .63)
	btn.item:SetHeight(10)
	
	btn.price = btn:CreateFontString(nil, "OVERLAY", "GameFontWhiteSmall")
	btn.price:SetJustifyH("RIGHT")
	btn.price:SetPoint("LEFT", btn.item, "RIGHT")
	btn.price:SetWidth(btnwidth * .37)
	btn.price:SetHeight(10)
	
	return btn;
end

local function UpdateContent()
	local btn
	
	if shoplist == nil then
		if #listobjs > 0 then
			for i = 1, #listobjs do
				listobjs[i]:Hide()
			end
		end
		return
	end	
	
	for i = 1, #shoplist do
		btn = listobjs[i]
		if btn == nil then 
			btn = CreateSelectionButton(i)
		end
		btn.item:SetText((shoplist[i].amt and shoplist[i].amt .. "x" or "")..select(2,GetItemInfo(shoplist[i].item)))
		btn.price:SetText(ns.BuildMoneyString(shoplist[i].price))
		m:mdebug("Item Price String", btn.price:GetText())
		btn:Show()
	end	
	
	if #shoplist < #listobjs then
		for i = #shoplist + 1, #listobjs do
			listobjs[i]:Hide()
		end
	end
	
	slider:SetMinMaxValues(0, max(0, 12 * #shoplist - scrollchild:GetHeight()))
end

local function ClearOnClick()
	wipe(shoplist)	
	UpdateContent()
end
clearbtn:SetScript("OnClick", ClearOnClick)

local function ClearOnUpdate(self)
	if #shoplist == 0 then
		self:Disable()
	else
		self:Enable()
	end
end
clearbtn:SetScript("OnUpdate", ClearOnUpdate)

local function RemoveOnClick()
	tremove(shoplist, selected)
	UpdateContent()
end
removebtn:SetScript("OnClick", RemoveOnClick)

local function RemoveOnUpdate(self)
	if selected == nil or selected > #shoplist then
		self:Disable()
	else
		self:Enable()
	end
end
removebtn:SetScript("OnUpdate", RemoveOnUpdate)

---Core functions---
function m:Show()
	frame:Show()
end

--SetList(name)
--Sets the list name and clears the list if it dosen't match the current name
--Does nothing if the list name matches
--List name is used when creating scanner shopping lists
function m:SetList(name)
	if name ~= listname then
		wipe(shoplist)
		listname = name
		listnametext:SetText(name)
		UpdateContent()
	end
end

--AddToList(item, price[,amt])
--Adds an item to the shopping list
--@item: the itemID of the item to add to the list
--@price: the price to show in the shopping list
--@amt: optional amount to place next to the item (ex: 4x[Iron Ore])
function m:AddToList(item, price, amt)
	tinsert(shoplist, {item = item, price = price, amt = amt})
	
	UpdateContent()
	--TODO: Update scanner lists
end
	
function m:ClearList()
	wipe(shoplist)
	
	UpdateContent()
end

m.TYCOON_CFG_READY = function(self)
	if ns.dbpc.sl_point then
		frame:SetPoint(ns.dbpc.sl_point, UIParent, ns.dbpc.sl_relpoint, ns.dbpc.sl_x, ns.dbpc.sl_y)
	end
end