﻿local AddonName, ns = ...
local m = ns:RegisterModule(nil, "StatusFrame")
local ManaCore = ManaCore
local slave = ManaCore:RegisterModule() --used to listen for neccecary ManaCore events

local DEFAULT_STATUS_TEXT = "Welcome to |cfffad700Tycoon|r! Click me!"

local f = CreateFrame("Button", "TycoonStatusFrame", UIParent)
f:SetHeight(22)
f:SetWidth(220)
f:EnableMouse(true)
f:SetFrameStrata("LOW")
f:SetPoint("CENTER")
f:Hide()

local g = CreateFrame("Button", "TycoonStatusRateFrame", f)
g:SetHeight(22)
g:SetWidth(75)
g:SetPoint("RIGHT", f, "LEFT")
g:Hide()

f.text = f:CreateFontString(nil, "OVERLAY", "GameFontWhite")
f.text:SetPoint("TOPLEFT", f, "TOPLEFT", 4, -4)
f.text:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -4, 4)
f.text:SetText(DEFAULT_STATUS_TEXT)
f.text:SetJustifyV("BOTTOM")
f.text:SetJustifyH("LEFT")

g.text = g:CreateFontString(nil, "OVERLAY", "GameFontWhite")
g.text:SetPoint("TOPLEFT", g, "TOPLEFT", 4, -4)
g.text:SetPoint("BOTTOMRIGHT", g, "BOTTOMRIGHT", -4, 4)
g.text:SetText(Tycoon.BuildMoneyString(90001111, true)..'/hr')
g.text:SetJustifyV("BOTTOM")
g.text:SetJustifyH("RIGHT")

f:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
               edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
               tile = true, tileSize = 16, edgeSize = 16, 
               insets = { left = 4, right = 4, top = 4, bottom = 4 }});
f:SetBackdropColor(0,0,0,1);

g:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
               edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
               tile = true, tileSize = 16, edgeSize = 16, 
               insets = { left = 4, right = 4, top = 4, bottom = 4 }});
g:SetBackdropColor(0,0,0,1);

function m:PositionStatusFrame()
	f:ClearAllPoints()
	if ns.dbpc.statusframepoint and ns.dbpc.statusframe_detached then
		f:SetPoint(ns.dbpc.statusframepoint, ns.dbpc.statusframex, ns.dbpc.statusframey)
	else
		f:SetPoint('TOP',ManaCore.vars.ringState and string.match(ManaCore.dbpc.ringLayout,'Ring') and ManaCoreRing or ManaCoreButton,'BOTTOM',0,ManaCore.vars.ringState and string.match(ManaCore.dbpc.ringLayout,'Ring') and 0 or 0)
	end
	
	--TODO: determine when the status frame should be shown or hidden
	--f:Show()
end

function m:SetText(input)
	f.text:SetText(input)
end

function m:SetRateText(input)
	g.text:SetText(input)	
end

function m:Show()
	f:Show()
end

function m:Hide()
	f:Hide()
end

function m:ShowRate()
	g:Show()
end

function m:HideRate()
	g:Hide()
end

local function GetUIParentAnchor(frame)
  local w, h, x, y = UIParent:GetWidth(), UIParent:GetHeight(), frame:GetCenter()
  local hhalf, vhalf = (x > w/2) and "RIGHT" or "LEFT", (y > h/2) and "TOP" or "BOTTOM"
  local dx = hhalf == "RIGHT" and math.floor(frame:GetRight() + 0.5) - w or math.floor(frame:GetLeft() + 0.5)
  local dy = vhalf == "TOP" and math.floor(frame:GetTop() + 0.5) - h or math.floor(frame:GetBottom() + 0.5)

  return vhalf..hhalf, dx, dy
end

f.OnDragStart = function(frame)
	--if not(frame:IsMovable()) or ns.dbpc.lock_frame == true then return end
  frame:StartMoving()
  ManaCore:FireEvent('GUIDE_FRAME_DRAG_START') --TODO: change to DOCKABLE_FRAME_DRAG_START
end

f.OnDragStop = function(frame)
  ManaCore:FireEvent('GUIDE_FRAME_DRAG_STOP') --TODO: change to DOCKABLE_FRAME_DRAG_STOP
  frame:StopMovingOrSizing()
  if ManaCoreRing:IsMouseOver() or ManaCoreButton:IsMouseOver() then
    ns.dbpc.statusframe_detached = false
    m.PositionStatusFrame()
    return
  end
  ns.dbpc.statusframepoint, ns.dbpc.statusframex, ns.dbpc.statusframey = GetUIParentAnchor(frame)
  frame:ClearAllPoints()
  frame:SetPoint(ns.dbpc.statusframepoint, ns.dbpc.statusframex, ns.dbpc.statusframey)
  ns.dbpc.statusframe_detached = true
end

f.OnClick = function(frame)
	if ns.vars.active_module then
		local module = ns:GetModule(ns.vars.active_module)
		if module and module.StatusOnClick then
			module.StatusOnClick()
			return
		end
	end
	
	if TycoonPanel:IsShown() then 
		HideUIPanel(TycoonPanel) 
	else
		ShowUIPanel(TycoonPanel)
	end
end

local hoverDelay = 0
local hoverWaiting = false
f.OnEnter = function(frame)
	m:mdebug("StatusFrame OnEnter")
	hoverDelay = 0;
	hoverWaiting = true;
end

f.OnLeave = function(frame)
	m:mdebug("StatusFrame OnLeave")
	hoverWaiting = false;
	GameTooltip:Hide()
end

f.OnUpdate = function(frame, elapsed)
	if hoverWaiting and MouseIsOver(frame) then
		hoverDelay = hoverDelay + elapsed
		if hoverDelay > 1 then
			hoverWaiting = false
			if ns.vars.active_module then
				local module = ns:GetModule(ns.vars.active_module)
				m:mdebug("StatusFrame: calling StatusOnHover", ns.vars.active_module)
				if module and module.StatusOnHover then
					module.StatusOnHover(frame)
					return
				end
			end
		end
	end
end

f:RegisterForDrag("LeftButton")
f:SetClampedToScreen(true);

m.TYCOON_CFG_READY = function()
  f:SetMovable(not(ns.dbpc.lock_frame))
  f:SetScript("OnDragStart", f.OnDragStart)
  f:SetScript("OnDragStop", f.OnDragStop)
	f:SetScript("OnClick", f.OnClick)
	f:SetScript("OnEnter", f.OnEnter)
	f:SetScript("OnLeave", f.OnLeave)
	f:SetScript("OnUpdate", f.OnUpdate)
  f:RegisterForDrag(not(ns.dbpc.lock_frame) and 'LeftButton' or nil)
end 

m.PLAYER_LOGIN = function()
	--At this point ManaCore's and Tycoon's DBs should be ready
	--This is not always true on TYCOON_CFG_READY
	--Change this when we go LOD
	m:PositionStatusFrame()
end
m:RegisterEvent("PLAYER_LOGIN")

slave.MANACORE_CFG_CHANGED = function(self, var, old, new)
	if(var == 'ringState') then
		m:PositionStatusFrame()
	end
end
slave:RegisterEvent("MANACORE_CFG_CHANGED")

slave.MANACORE_VARS_CHANGED = function(self, var, old, new)
	if var == "active_product" then
		if new == "Tycoon" then
			f:Show()
			g:Hide()
			f:SetText(DEFAULT_STATUS_TEXT)
			ns.vars.active_module = nil;
		else
			f:Hide()
		end
	end
end
slave:RegisterEvent("MANACORE_VARS_CHANGED")
	