﻿local AddonName,ns = ...
local m,i = ns:RegisterModule(nil,"UI")
local CoreUI = ManaCore:GetModule('RingUI')
if CoreUI then return end

--NOTE: This file is depreciated and exists for reference
--TODO:replace ring with dropdown if used, or anchor/child this ring to the ManaCore ring
m.frame = CoreUI:CreateRing("TycoonFrame", UIParent, -90, 90)
local f = m.frame
f:SetSize(100,100)
f:SetPoint("CENTER", "UIParent", "CENTER")
f:EnableMouse(true)
f:RegisterForDrag("LeftButton");
f:SetMovable(true)
f:SetScript("OnDragStart", f.StartMoving)
f:SetScript("OnDragStop", f.StopMovingOrSizing)
f:Show()

f.border = f:CreateTexture(nil, "ARTWORK")
f.border:SetTexture("Interface\\Minimap\\UI-Minimap-Border")
f.border:SetTexCoord(.37, .94, .125, .7)
f.border:SetPoint("TOPLEFT")
f.border:SetPoint("BOTTOMRIGHT")

--temporary for display/debug purposes
f.background = f:CreateTexture(nil, "BACKGROUND")
f.background:SetTexture([[Interface\Tooltips\UI-Tooltip-Background]])
f.background:SetAllPoints(true)
f.background:SetVertexColor(0,0,0,.5)

--[[
f.text = f:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
f.text:SetPoint("BOTTOMLEFT", f, "BOTTOMLEFT", 0, 10)
f.text:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", 0, 10)
f.text:SetText("[PH] Status Text")
f.text:Show()
]]--

--TODO:anchor/child this to the ManaCore ring, or make this completely standalone
f.statusframe = CreateFrame("Frame", nil, f)
f.statusframe:SetSize(150, 20)
f.statusframe:SetPoint("BOTTOMRIGHT", f, "BOTTOMLEFT", 0, 0)
f.statusframe:Show()

f.statusframe.background = f.statusframe:CreateTexture(nil, "BACKGROUND")
f.statusframe.background:SetTexture([[Interface\Tooltips\UI-Tooltip-Background]])
f.statusframe.background:SetVertexColor(0,0,0,.5)
f.statusframe.background:Show()
f.statusframe.background:SetAllPoints(true)

f.statusframe.text = f.statusframe:CreateFontString(nil, "OVERLAY", "GameFontNormalSmall")
f.statusframe.text:SetPoint("BOTTOMLEFT", f.statusframe, "BOTTOMLEFT", 0, 5)
f.statusframe.text:SetPoint("BOTTOMRIGHT", f.statusframe, "BOTTOMRIGHT", 0, 5)
f.statusframe.text:SetJustifyH("LEFT")
f.statusframe.text:SetText("[PH] Status Text")
f.statusframe.text:Show()

local function createModuleButton(ring, modname, onTex, offTex) 
  local f = ring:CreateButton()
  f.modname = modname
  
  f:SetSize(16,16)
  
  f.border = f:CreateTexture(nil, "ARTWORK")
  f.border:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder")
  f.border:SetSize(26, 26)
  f.border:SetPoint("TOPLEFT")
  
  f:SetNormalTexture(onTex)
  f:SetHighlightTexture(onTex)
  f:SetDisabledTexture(offTex)
  
  if(not ns.RegisteredModules[modname]) then f:Disable() end
  if(modname == ns.dbpc.active_module) then f:LockHighlight() end
  
  f:SetScript("OnClick", function()
    ns.vars.active_module = f.modname
  end)
  
  f:Show()
  m[modname] = f
  return f  
end

local loaded
m.TYCOON_CFG_READY = function (self)
	if loaded then return end
  
  ns.dbpc.active_module = "UI"
  createModuleButton(m.frame, "UI", "Interface\\AddOns\\Booster\\Images\\muleshopper_open", "Interface\\AddOns\\Booster\\Images\\comments_off")
  createModuleButton(m.frame, "Mod2", "Interface\\AddOns\\Booster\\Images\\talents_on", "Interface\\AddOns\\Booster\\Images\\talents_off")
  
	loaded = true
end
